/*
 * frm_texto.java
 *
 * Created on 20 de Agosto de 2006, 14:38
 */

package protej;

import java.awt.Rectangle;
import java.util.Date;
import protej.processador_texto;
import protej.dlg_tarefas;
import java.awt.Toolkit;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.datatransfer.StringSelection;
import java.io.IOException;
import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.*;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.UndoManager;

/**
 *
 * @author  arnaldo
 */
public class frm_texto extends javax.swing.JFrame implements protej_avisos, UndoableEditListener, DocumentListener {
    
    
    public void aviso(String mensagem) {
        op_mensagem.showMessageDialog(frm_texto.this, mensagem, "Aviso", JOptionPane.WARNING_MESSAGE);
    }
    
    public void changedUpdate(DocumentEvent e) {
        texto_alterado = true;
    }

    public void erro(String mensagem) {
        lbl_status.setForeground(new java.awt.Color(200, 0, 0));
        lbl_status.setText(mensagem);
    }
    
    /** Creates new form frm_texto */
    public frm_texto() {
        // inicialização automática de componentes
        initComponents();
        // inicialização de componentes do usuário
        setExtendedState(JFrame.MAXIMIZED_BOTH);
        pack();
        desfazer = new UndoManager();
        editor = new processador_texto(txt_texto);
        fc_arquivo = new javax.swing.JFileChooser();
        fc_diretorio = new javax.swing.JFileChooser();
        fc_diretorio.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        fc_diretorio.setMultiSelectionEnabled(true);
        op_mensagem = new javax.swing.JOptionPane();
        protej = new protej(this, editor);
        frm_seleciona_tarefa = new dlg_tarefas(protej);
        frm_status = new dlg_status(protej);
        if (protej.tarefas[protej.tarefa_selecionada].habilitado) {
            status_semlog("Tarefa: " + protej.tarefas[protej.tarefa_selecionada].descricao);
        }
        texto_alterado = false;
        txt_texto.getDocument().addDocumentListener(this);
        txt_texto.getDocument().addUndoableEditListener(this);
    }
    
    public void insertUpdate(DocumentEvent e) {
        texto_alterado = true;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    javax.swing.UIManager.setLookAndFeel(javax.swing.UIManager.getSystemLookAndFeelClassName());
                } catch(Exception e) {
                    System.out.println("Error setting native LAF: " + e);
                }
                new frm_texto().setVisible(true);
            }
        });
    }
    
    public void progresso(int atual, int total) {
        //
        // atualiza a porcentagem da tarefa sendo realizada
        //
        if (total == 0) {
            this.frm_status.pb_progresso.setValue(0);
        } else {
            this.frm_status.pb_progresso.setValue((int) (atual * 100 / total));
        }
    }
    
    public void removeUpdate(DocumentEvent e) {
        texto_alterado = true;
    }

    public void seta_texto_alterado(boolean valor) {
        //
        // define um valor para a variavel texto alterado
        //
        texto_alterado = valor;
    }
    
    public void status(String mensagem) {
        //
        // mostra o status da ação corrente na janela atual e na janela de status
        //
        Date data;
        Rectangle visivel;
        // atualizando status
        lbl_status.setText(mensagem);
        lbl_status.setForeground(new java.awt.Color(0, 100, 0));
        this.frm_status.txt_status.append(mensagem + "\n");
        // refrescando a tela ( a cada meio segundo)
        data = new java.util.Date();
        if (data.getTime() - this.ultimo_repaint > 2000) {
            this.paintComponents(this.getGraphics());
            this.frm_status.pnl_status.paintComponents(
                    this.frm_status.pnl_status.getGraphics()); // atualiza getBounds
            visivel = this.frm_status.txt_status.getVisibleRect();
            visivel.y = this.frm_status.txt_status.getBounds().height - visivel.height;
            this.frm_status.txt_status.scrollRectToVisible(visivel);
            this.frm_status.paintComponents(this.frm_status.getGraphics()); // refresca tela
            this.ultimo_repaint = data.getTime();
        }
    }

    public void status_semlog(String mensagem) {
        //
        // mostra o status de uma ação na janela corrente
        //
        lbl_status.setForeground(new java.awt.Color(0, 100, 0));
        lbl_status.setText(mensagem);
        //this.repaint();
    }

    
    public void undoableEditHappened(UndoableEditEvent e) {
        if (!processa_lote) {
            desfazer.addEdit(e.getEdit());
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnl_texto = new javax.swing.JScrollPane();
        txt_texto = new javax.swing.JTextArea();
        bnt_executar = new javax.swing.JButton();
        bnt_avancar = new javax.swing.JButton();
        bnt_voltar = new javax.swing.JButton();
        txt_buscar = new javax.swing.JTextField();
        bnt_buscar = new javax.swing.JButton();
        lbl_status = new javax.swing.JLabel();
        bnt_executar_serie = new javax.swing.JButton();
        bnt_tarefas = new javax.swing.JButton();
        bnt_voltar_inicio = new javax.swing.JButton();
        bnt_avancar_fim = new javax.swing.JButton();
        bnt_refazer = new javax.swing.JButton();
        bnt_desfazer = new javax.swing.JButton();
        bnt_status = new javax.swing.JButton();
        mnb_menu = new javax.swing.JMenuBar();
        mnu_arquivo = new javax.swing.JMenu();
        mnu_abrir = new javax.swing.JMenuItem();
        mnu_salvar = new javax.swing.JMenuItem();
        mnu_salvar_como = new javax.swing.JMenuItem();
        mnu_fechar = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        mnu_sair = new javax.swing.JMenuItem();
        mnu_editar = new javax.swing.JMenu();
        mnu_desfazer = new javax.swing.JMenuItem();
        mnu_refazer = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        mnu_recortar = new javax.swing.JMenuItem();
        mnu_copiar = new javax.swing.JMenuItem();
        mnu_colar = new javax.swing.JMenuItem();
        mnu_tarefas = new javax.swing.JMenu();
        mnu_executar_tarefa = new javax.swing.JMenuItem();
        mnu_executar_serie = new javax.swing.JMenuItem();
        mnu_selecionar_tarefa = new javax.swing.JMenuItem();
        mnu_ver_status = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("PROTEJ - PRocessador de TExtos históricos em Java");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        txt_texto.setColumns(20);
        txt_texto.setEditable(false);
        txt_texto.setLineWrap(true);
        txt_texto.setRows(5);
        txt_texto.setWrapStyleWord(true);
        pnl_texto.setViewportView(txt_texto);

        bnt_executar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gear.gif"))); // NOI18N
        bnt_executar.setToolTipText("Executar");
        bnt_executar.setIconTextGap(0);
        bnt_executar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_executarActionPerformed(evt);
            }
        });

        bnt_avancar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gtk-go-forward-ltr.jpg"))); // NOI18N
        bnt_avancar.setToolTipText("Avançar");
        bnt_avancar.setIconTextGap(0);
        bnt_avancar.setMargin(new java.awt.Insets(2, 2, 2, 2));
        bnt_avancar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_avancarActionPerformed(evt);
            }
        });

        bnt_voltar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gtk-go-back-ltr.jpg"))); // NOI18N
        bnt_voltar.setToolTipText("Voltar");
        bnt_voltar.setIconTextGap(0);
        bnt_voltar.setMargin(new java.awt.Insets(2, 2, 2, 2));
        bnt_voltar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_voltarActionPerformed(evt);
            }
        });

        txt_buscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_buscarActionPerformed(evt);
            }
        });

        bnt_buscar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gnome-searchtool.jpg"))); // NOI18N
        bnt_buscar.setToolTipText("Buscar");
        bnt_buscar.setIconTextGap(0);
        bnt_buscar.setMargin(new java.awt.Insets(2, 2, 2, 2));
        bnt_buscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_buscarActionPerformed(evt);
            }
        });

        lbl_status.setFont(new java.awt.Font("Dialog", 1, 18));
        lbl_status.setForeground(new java.awt.Color(0, 100, 0));
        lbl_status.setText("Tarefa:");

        bnt_executar_serie.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gear2.gif"))); // NOI18N
        bnt_executar_serie.setToolTipText("Executar em série");
        bnt_executar_serie.setIconTextGap(0);
        bnt_executar_serie.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_executar_serieActionPerformed(evt);
            }
        });

        bnt_tarefas.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gnome-devel.gif"))); // NOI18N
        bnt_tarefas.setToolTipText("Selecionar tarefas");
        bnt_tarefas.setIconTextGap(0);
        bnt_tarefas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_tarefasActionPerformed(evt);
            }
        });

        bnt_voltar_inicio.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gtk-goto-first-ltr.gif"))); // NOI18N
        bnt_voltar_inicio.setToolTipText("Voltar para início");
        bnt_voltar_inicio.setIconTextGap(0);
        bnt_voltar_inicio.setMargin(new java.awt.Insets(2, 2, 2, 2));
        bnt_voltar_inicio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_voltar_inicioActionPerformed(evt);
            }
        });

        bnt_avancar_fim.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gtk-goto-last-ltr.gif"))); // NOI18N
        bnt_avancar_fim.setToolTipText("Avançar para fim");
        bnt_avancar_fim.setIconTextGap(0);
        bnt_avancar_fim.setMargin(new java.awt.Insets(2, 2, 2, 2));
        bnt_avancar_fim.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_avancar_fimActionPerformed(evt);
            }
        });

        bnt_refazer.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gtk-redo-ltr.png"))); // NOI18N
        bnt_refazer.setToolTipText("Refazer");
        bnt_refazer.setIconTextGap(0);
        bnt_refazer.setMargin(new java.awt.Insets(2, 2, 2, 2));
        bnt_refazer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_refazerActionPerformed(evt);
            }
        });

        bnt_desfazer.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gtk-undo-ltr.gif"))); // NOI18N
        bnt_desfazer.setToolTipText("Desfazer");
        bnt_desfazer.setIconTextGap(0);
        bnt_desfazer.setMargin(new java.awt.Insets(2, 2, 2, 2));
        bnt_desfazer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_desfazerActionPerformed(evt);
            }
        });

        bnt_status.setIcon(new javax.swing.ImageIcon(getClass().getResource("/logviewer.png"))); // NOI18N
        bnt_status.setToolTipText("Ver status");
        bnt_status.setIconTextGap(0);
        bnt_status.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_statusActionPerformed(evt);
            }
        });

        mnu_arquivo.setText("Arquivo");

        mnu_abrir.setText("Abrir");
        mnu_abrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_abrirActionPerformed(evt);
            }
        });
        mnu_arquivo.add(mnu_abrir);

        mnu_salvar.setText("Salvar");
        mnu_salvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_salvarActionPerformed(evt);
            }
        });
        mnu_arquivo.add(mnu_salvar);

        mnu_salvar_como.setText("Salvar como");
        mnu_salvar_como.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_salvar_comoActionPerformed(evt);
            }
        });
        mnu_arquivo.add(mnu_salvar_como);

        mnu_fechar.setText("Fechar");
        mnu_fechar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_fecharActionPerformed(evt);
            }
        });
        mnu_arquivo.add(mnu_fechar);
        mnu_arquivo.add(jSeparator1);

        mnu_sair.setText("Sair");
        mnu_sair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_sairActionPerformed(evt);
            }
        });
        mnu_arquivo.add(mnu_sair);

        mnb_menu.add(mnu_arquivo);

        mnu_editar.setText("Editar");

        mnu_desfazer.setText("Desfazer");
        mnu_desfazer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_desfazerActionPerformed(evt);
            }
        });
        mnu_editar.add(mnu_desfazer);

        mnu_refazer.setText("Refazer");
        mnu_refazer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_refazerActionPerformed(evt);
            }
        });
        mnu_editar.add(mnu_refazer);
        mnu_editar.add(jSeparator2);

        mnu_recortar.setText("Recortar");
        mnu_recortar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_recortarActionPerformed(evt);
            }
        });
        mnu_editar.add(mnu_recortar);

        mnu_copiar.setText("Copiar");
        mnu_copiar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_copiarActionPerformed(evt);
            }
        });
        mnu_editar.add(mnu_copiar);

        mnu_colar.setText("Colar");
        mnu_colar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_colarActionPerformed(evt);
            }
        });
        mnu_editar.add(mnu_colar);

        mnb_menu.add(mnu_editar);

        mnu_tarefas.setText("Tarefas");

        mnu_executar_tarefa.setText("Executar tarefa");
        mnu_executar_tarefa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_executarActionPerformed(evt);
            }
        });
        mnu_tarefas.add(mnu_executar_tarefa);

        mnu_executar_serie.setText("Executar em série");
        mnu_executar_serie.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_executar_serieActionPerformed(evt);
            }
        });
        mnu_tarefas.add(mnu_executar_serie);

        mnu_selecionar_tarefa.setText("Selecionar tarefas");
        mnu_selecionar_tarefa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bnt_tarefasActionPerformed(evt);
            }
        });
        mnu_tarefas.add(mnu_selecionar_tarefa);

        mnu_ver_status.setText("Ver status");
        mnu_ver_status.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mnu_ver_statusActionPerformed(evt);
            }
        });
        mnu_tarefas.add(mnu_ver_status);

        mnb_menu.add(mnu_tarefas);

        setJMenuBar(mnb_menu);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lbl_status)
                    .add(pnl_texto, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 727, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(bnt_voltar_inicio)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_voltar)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_avancar)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_avancar_fim)
                        .add(24, 24, 24)
                        .add(bnt_executar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_executar_serie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_tarefas, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_status, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(21, 21, 21)
                        .add(bnt_desfazer)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_refazer)
                        .add(25, 25, 25)
                        .add(txt_buscar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 154, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(bnt_buscar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(txt_buscar)
                        .add(org.jdesktop.layout.GroupLayout.TRAILING, bnt_buscar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_status, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_tarefas, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_executar_serie, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_executar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_avancar_fim, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_avancar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_voltar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_voltar_inicio, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_refazer, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, bnt_desfazer, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(lbl_status)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(pnl_texto, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 313, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void mnu_ver_statusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_ver_statusActionPerformed
        //
        // chama bnt_statusActionPerformed
        //
        this.bnt_statusActionPerformed(null);
    }//GEN-LAST:event_mnu_ver_statusActionPerformed

    private void bnt_statusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_statusActionPerformed
        //
        // mostra o formulário de status
        //
        this.frm_status.setVisible(true);
    }//GEN-LAST:event_bnt_statusActionPerformed

    private void txt_buscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_buscarActionPerformed
        //
        // dispara o botão de busca quando o usuário pressiona enter
        //
        this.bnt_buscarActionPerformed(null);
    }//GEN-LAST:event_txt_buscarActionPerformed

    private void bnt_desfazerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_desfazerActionPerformed
        //
        // desfaz a última ação feita pelo usuário
        //
        mnu_desfazerActionPerformed(null);
    }//GEN-LAST:event_bnt_desfazerActionPerformed

    private void bnt_refazerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_refazerActionPerformed
        //
        // refaz a última ação feita pelo usuário
        //
        mnu_refazerActionPerformed(null);
    }//GEN-LAST:event_bnt_refazerActionPerformed

    private void bnt_avancar_fimActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_avancar_fimActionPerformed
        //
        // avança para última tarefa da lista
        //
        while (protej.avanca_tarefa());
        status_semlog("Tarefa: " + protej.tarefas[protej.tarefa_selecionada].descricao);
    }//GEN-LAST:event_bnt_avancar_fimActionPerformed

    private void bnt_voltar_inicioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_voltar_inicioActionPerformed
        //
        // volta para primeira tarefa da lista
        //
        while (protej.volta_tarefa());
        status_semlog("Tarefa: " + protej.tarefas[protej.tarefa_selecionada].descricao);

    }//GEN-LAST:event_bnt_voltar_inicioActionPerformed

    private void bnt_tarefasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_tarefasActionPerformed
        //
        // exibe a caixa de dialogo com as tarefas disponíveis
        //
        frm_seleciona_tarefa.setVisible(true);
        if (protej.tarefas[protej.tarefa_selecionada].habilitado) {
            status("Tarefa: " + protej.tarefas[protej.tarefa_selecionada].descricao);
        } else {
            status("Tarefa: ");
        }
    }//GEN-LAST:event_bnt_tarefasActionPerformed
    
    private void bnt_buscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_buscarActionPerformed
        //
        // efetua uma busca no texto por palavras
        //
        
        int posicao_atual; 
        String texto = this.txt_buscar.getText();
        if (texto.equals("")) {
            aviso("é necessário definir um texto de busca válido");
            return;
        }
        txt_texto.setSelectionStart(txt_texto.getSelectionEnd());
        // cursor start = cursor end
        txt_texto.grabFocus();
        editor.atualiza_cursor_interno();
        posicao_atual = editor.le_posicao();
        if (! editor.encontra_texto(1, texto)) {
            aviso("Item não encontrado");
        } else {
            editor.atualiza_cursor_externo();
            txt_texto.setSelectionEnd(txt_texto.getSelectionStart() + texto.length());
        }
    }//GEN-LAST:event_bnt_buscarActionPerformed

    private void bnt_executar_serieActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_executar_serieActionPerformed
        //
        // executa ações em série até a intervenção do usuário ser requerida por alguma das tarefas
        //
        protej.gera_corpus_nano_philologic();
        if (true) return;
        /*
        processa_lote = true;
        int escolha = fc_diretorio.showOpenDialog(frm_texto.this);
        if (escolha == JFileChooser.APPROVE_OPTION) {
            this.mnu_fecharActionPerformed(evt); // salva o texto
            if (texto_alterado) {
                return;
            }
            protej.diretorios_origem = fc_diretorio.getSelectedFiles();
            frm_status.setVisible(true);
            protej.remove_choice_tudo();
        }
        processa_lote = false;
        if (true) return;*/
        // real code
        if (editor.pega_arquivo_aberto().equals("")) {
            aviso("Nenhum arquivo aberto");
            return;
        }
        while (protej.tarefas[protej.tarefa_selecionada].executa()) {
            if (! protej.avanca_tarefa()) {
                break;
            }
        }
        editor.atualiza_cursor_externo();
    }//GEN-LAST:event_bnt_executar_serieActionPerformed
    
    private void bnt_voltarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_voltarActionPerformed
        //
        // volta para a tarefa anterior se possivel
        //
        if (protej.volta_tarefa()) {
            status_semlog("Tarefa: " + protej.tarefas[protej.tarefa_selecionada].descricao);
        }
    }//GEN-LAST:event_bnt_voltarActionPerformed
    
    private void bnt_avancarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_avancarActionPerformed
        //
        // avanca para a proxima tarefa se possivel
        //
        if (protej.avanca_tarefa()) {
            status_semlog("Tarefa: " + protej.tarefas[protej.tarefa_selecionada].descricao);
        }
    }//GEN-LAST:event_bnt_avancarActionPerformed
    
    private void mnu_refazerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_refazerActionPerformed
        //
        // refaz a última ação feita pelo usuário
        //
        try {
            desfazer.redo();
        } catch (CannotRedoException ex) {
            System.out.println("Unable to redo: " + ex);
            ex.printStackTrace();
        }
        txt_texto.grabFocus();
    }//GEN-LAST:event_mnu_refazerActionPerformed
    
    private void mnu_desfazerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_desfazerActionPerformed
        //
        // desfaz a última ação feita pelo usuário
        //
        try {
            desfazer.undo();
        } catch (CannotUndoException ex) {
            System.out.println("Unable to undo: " + ex);
            ex.printStackTrace();
        }
        txt_texto.grabFocus();
    }//GEN-LAST:event_mnu_desfazerActionPerformed
    
    private void mnu_recortarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_recortarActionPerformed
        //
        // recorta o texto selecionado para a área de transferência
        //
        if (editor.pega_arquivo_aberto().equals("") || txt_texto.getSelectedText().equals(null)) {
            return;
        }
        StringSelection texto = new StringSelection(txt_texto.getSelectedText());
        Toolkit.getDefaultToolkit().getSystemClipboard().setContents(texto, null);
        txt_texto.replaceSelection("");
    }//GEN-LAST:event_mnu_recortarActionPerformed
    
    private void mnu_colarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_colarActionPerformed
        //
        // cola um texto da área de transferência
        //
        Transferable area_de_transferencia = Toolkit.getDefaultToolkit().getSystemClipboard().getContents(null);
        String texto;
        if (editor.pega_arquivo_aberto().equals("")) {
            return;
        }
        try {
            if (area_de_transferencia != null && area_de_transferencia.isDataFlavorSupported(DataFlavor.stringFlavor)) {
                texto = (String) area_de_transferencia.getTransferData(DataFlavor.stringFlavor);
                editor.insere_direita(texto);
            }
        } catch (UnsupportedFlavorException e) {
        } catch (IOException e) {
        }
    }//GEN-LAST:event_mnu_colarActionPerformed
    
    private void mnu_copiarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_copiarActionPerformed
        //
        // copia o texto selecionado para a área de transferência
        //
        if (editor.pega_arquivo_aberto().equals("") || txt_texto.getSelectedText().equals(null)) {
            return;
        }
        StringSelection texto = new StringSelection(txt_texto.getSelectedText());
        Toolkit.getDefaultToolkit().getSystemClipboard().setContents(texto, null);
    }//GEN-LAST:event_mnu_copiarActionPerformed
    
    private void mnu_sairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_sairActionPerformed
        //
        // encerra a aplicação
        //
        this.formWindowClosing(null);
        System.exit(0);
    }//GEN-LAST:event_mnu_sairActionPerformed
    
    private void mnu_salvar_comoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_salvar_comoActionPerformed
        //
        // salva o documento com um nome diferente
        //
        int escolha;
        String nome_arquivo;
        if (editor.pega_arquivo_aberto().equals("")) {
            return;
        }
        escolha = fc_arquivo.showSaveDialog(frm_texto.this);
        if (escolha == JFileChooser.APPROVE_OPTION) {
            nome_arquivo = fc_arquivo.getSelectedFile().getAbsolutePath();
            if (editor.salva_arquivo(nome_arquivo)) {
                this.setTitle("PROTEJ - " + nome_arquivo);
                texto_alterado = false;
            } else {
                aviso("Falha ao salvar arquivo");
            }
        }
    }//GEN-LAST:event_mnu_salvar_comoActionPerformed
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        //
        // fecha o documento ativo salvando as alterações caso o usuário deseje
        //
        
        int resposta;
        String mensagem = "O texto foi alterado. Deseja salvar as alterações?";
        if (texto_alterado) {
            resposta = op_mensagem.showConfirmDialog(frm_texto.this, mensagem, "Aviso", JOptionPane.YES_NO_OPTION);
            if (resposta == JOptionPane.YES_OPTION) {
                editor.salva_arquivo("");
            }
        }
    }//GEN-LAST:event_formWindowClosing
    
    private void mnu_fecharActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_fecharActionPerformed
        //
        // fecha o documento ativo salvando as alterações caso o usuário deseje
        //
        int resposta;
        String mensagem = "O texto foi alterado. Deseja salvar as alterações?";
        if (texto_alterado) {
            resposta = op_mensagem.showConfirmDialog(frm_texto.this, mensagem, "Aviso", JOptionPane.YES_NO_CANCEL_OPTION);
            if (resposta == JOptionPane.YES_OPTION) {
                editor.salva_arquivo("");
                texto_alterado = false;
            } else if (resposta == JOptionPane.CANCEL_OPTION) {
                return;
            }
        }
        editor.fecha_arquivo();
        texto_alterado = false;
        txt_texto.setEditable(false);
        this.setTitle("PROTEJ - PRocessador de TExtos hist\u00f3ricos em Java");
    }//GEN-LAST:event_mnu_fecharActionPerformed
    
    private void mnu_abrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_abrirActionPerformed
        //
        // exibe diálogo para abertura de arquivo e carrega o arquivo no text_area
        //
        int escolha;
        String nome_arquivo = "";
        // selecionando o arquivo
        escolha = fc_arquivo.showOpenDialog(frm_texto.this);
        if (escolha == JFileChooser.APPROVE_OPTION) {
            // salvando texto anterior
            this.mnu_fecharActionPerformed(evt);
            if (texto_alterado) {
                return;
            }
            nome_arquivo = fc_arquivo.getSelectedFile().getAbsolutePath();
            //op_mensagem.showMessageDialog(frm_texto.this, "Arquivo selectionado " + arquivo, "Aviso", JOptionPane.WARNING_MESSAGE);
            if (editor.abre_arquivo(nome_arquivo)) {
                txt_texto.setEditable(true);
                texto_alterado = false;
                this.setTitle("PROTEJ - " + nome_arquivo);
                desfazer.discardAllEdits();
            } else {
                aviso("Falha ao abir arquivo.\nVerifique se a codificação de caracteres está correta");
            }
        }
    }//GEN-LAST:event_mnu_abrirActionPerformed
    
    private void mnu_salvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mnu_salvarActionPerformed
        //
        // salva o documento ativo
        //
        if (editor.pega_arquivo_aberto().equals("")) {
            return;
        }
        if (editor.salva_arquivo("")) {
            texto_alterado = false;
        } else {
            aviso("Falha ao salvar");
        }
    }//GEN-LAST:event_mnu_salvarActionPerformed
    
    private void bnt_executarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bnt_executarActionPerformed
        //
        // executa a ação selecionada pelo usuário
        //
        int escolha;
        txt_texto.grabFocus();
        if (!protej.tarefas[protej.tarefa_selecionada].processa_lote) {
            // usando arquivo aberto
            processa_lote = false;
            if (editor.pega_arquivo_aberto().equals("")) {
                aviso("Nenhum arquivo aberto");
                return;
            }
        } else {
            // solicitando diretório ao usuário
            escolha = fc_diretorio.showOpenDialog(frm_texto.this);
            if (escolha == JFileChooser.APPROVE_OPTION) {
                this.mnu_fecharActionPerformed(evt); // salva o texto
                if (texto_alterado) {
                    return;
                }
                protej.diretorios_origem = fc_diretorio.getSelectedFiles();
                frm_status.setVisible(true);
            } else {
                return;
            }
            processa_lote = true;
        }
        this.frm_status.pb_progresso.setValue(0);
        this.frm_status.txt_status.setText("");
        if (protej.tarefas[protej.tarefa_selecionada].executa()) {
            this.frm_status.pb_progresso.setValue(100);
        }
        processa_lote = false;
        editor.atualiza_cursor_externo();
    }//GEN-LAST:event_bnt_executarActionPerformed

    // variáveis do usuário
    protected UndoManager desfazer;
    private processador_texto editor;
    private javax.swing.JFileChooser fc_arquivo;
    private javax.swing.JFileChooser fc_diretorio;
    private dlg_tarefas frm_seleciona_tarefa;
    private dlg_status frm_status;
    private javax.swing.JOptionPane op_mensagem;
    private boolean processa_lote = false;
    public protej protej;
    private long ultimo_repaint;
    private boolean texto_alterado;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bnt_avancar;
    private javax.swing.JButton bnt_avancar_fim;
    private javax.swing.JButton bnt_buscar;
    private javax.swing.JButton bnt_desfazer;
    private javax.swing.JButton bnt_executar;
    private javax.swing.JButton bnt_executar_serie;
    private javax.swing.JButton bnt_refazer;
    private javax.swing.JButton bnt_status;
    private javax.swing.JButton bnt_tarefas;
    private javax.swing.JButton bnt_voltar;
    private javax.swing.JButton bnt_voltar_inicio;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JLabel lbl_status;
    private javax.swing.JMenuBar mnb_menu;
    private javax.swing.JMenuItem mnu_abrir;
    private javax.swing.JMenu mnu_arquivo;
    private javax.swing.JMenuItem mnu_colar;
    private javax.swing.JMenuItem mnu_copiar;
    private javax.swing.JMenuItem mnu_desfazer;
    private javax.swing.JMenu mnu_editar;
    private javax.swing.JMenuItem mnu_executar_serie;
    private javax.swing.JMenuItem mnu_executar_tarefa;
    private javax.swing.JMenuItem mnu_fechar;
    private javax.swing.JMenuItem mnu_recortar;
    private javax.swing.JMenuItem mnu_refazer;
    private javax.swing.JMenuItem mnu_sair;
    private javax.swing.JMenuItem mnu_salvar;
    private javax.swing.JMenuItem mnu_salvar_como;
    private javax.swing.JMenuItem mnu_selecionar_tarefa;
    private javax.swing.JMenu mnu_tarefas;
    private javax.swing.JMenuItem mnu_ver_status;
    private javax.swing.JScrollPane pnl_texto;
    private javax.swing.JTextField txt_buscar;
    public javax.swing.JTextArea txt_texto;
    // End of variables declaration//GEN-END:variables
    
}
