 /*
 * protej.java
 *
 * Created on 5 de Setembro de 2006, 15:18
 *
 */

package protej;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Date;
import java.util.Hashtable;

/**
 *
 * @author arnaldo
 */
public class protej {

    public class enum_tarefa {
        //
        // associa cada tarefa a um identificador
        //
        public int etiqueta_notas_linhas;
        public int etiqueta_notas_palavras;
        public int converte_notas_alfabeticas;
        public int converte_notas_asteriscos;
        public int converte_notas_multipaginas;
        public int converte_notas_parenteses;
        public int gerar_corpus_nano;
        public int gerar_corpus_philologic;
        public int gerar_corpus_unitex;
        public int cria_dicionario_abreviaturas;
        public int cria_dicionario_variantes;
        public int etiqueta_numeracao_paginas;
        public int remove_carriage_return;
        public int remove_ficha_catalografica;
        public int remove_igual;
        public int remove_marcadores;
        public int remove_numeracao_marginal;
        public int remove_numeracao_paragrafos;
        public int substitui_barrabarra;
        public int substui_i;
        public int substui_i_rodape;
        public int verifica_numeracao;
    }
    
    public class ficha_catalografica {
        public String autor = "";
        public String data_autor = "";
        public String data_edicao = "";
        public String data_publicacao = "";
        public String titulo = "";
    }

    // atributos da classe
    public File[] diretorios_origem = null;
    public enum_tarefa enum_tarefa = new enum_tarefa();
    public boolean etiquetar_notas_fim_pagina = true;
    public boolean etiquetar_primeira_linha = true;
    public boolean incluir_arquivo_etiqueta_paginas = true;
    private String inicio_marcacao_paragrafo = "";
    private protej_avisos mensageiro;
    private processador_texto editor;
    public int tamanho_enum_tarefa = 22;
    public int tarefa_selecionada = 0;
    public tarefa[] tarefas = new tarefa[tamanho_enum_tarefa];
    private java.util.Date tempo_corrente = new java.util.Date();
    private long ultima_atualizacao_progresso = 0;
        
    public boolean avanca_tarefa() {
        //
        // seleciona a proxima tarefa
        //
        int nova_tarefa = tarefa_selecionada;
        nova_tarefa++;
        while (nova_tarefa < tamanho_enum_tarefa && tarefas[nova_tarefa].habilitado == false) {
            nova_tarefa++;
        }
        if (nova_tarefa < tamanho_enum_tarefa) {
            tarefa_selecionada = nova_tarefa;
            return true;
        } else {
            return false;
        }
    }
    
    private String calcula_texto_adicional() {
        //
        // retira o diretório e a extensão do nome do arquivo do documento corrente
        //
        String texto_adicional = editor.pega_arquivo_aberto();
        texto_adicional = texto_adicional.substring(texto_adicional.lastIndexOf(java.io.File.separator) + 1);
        texto_adicional = texto_adicional.substring(0, texto_adicional.lastIndexOf("."));
        return texto_adicional;
    }
   
    private Hashtable carrega_alfabeto(String arquivo_alfabeto) {
        //
        // le arquivo de alfabeto do unitex e armazena em um hash
        //
        Hashtable<String, Integer> alfabeto = new Hashtable<String, Integer>();
        FileInputStream alvo;
        InputStreamReader byte_para_char;
        int char_unicode;
        Reader leitor;
        try {
            alvo = new FileInputStream(arquivo_alfabeto);
            byte_para_char = new InputStreamReader(alvo, "UTF-16LE");
            leitor = new BufferedReader(byte_para_char);
            while ((char_unicode = leitor.read()) > -1) {
                if (char_unicode != 0xFEFF && char_unicode != '\n' && char_unicode != '\r' ) {
                    alfabeto.put(String.valueOf((char) char_unicode), char_unicode);
                }
            }
            leitor.close();
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
        return alfabeto;
    }


    private boolean carrega_alfabeto(String arquivo_alfabeto, 
            Hashtable<String, String> alfabeto,
            Hashtable<String, String> alfabeto_maiusculo,
            Hashtable<String, String> alfabeto_minusculo) {
        //
        // cria 3 hashes para letras maiusculas, minusculas e todas
        //
        FileInputStream alvo;
        InputStreamReader byte_para_char;
        int char_unicode;
        boolean comeco_linha = true;
        Reader leitor;
        String maiuscula;
        String minuscula;
        try {
            alvo = new FileInputStream(arquivo_alfabeto);
            byte_para_char = new InputStreamReader(alvo, "UTF-16LE");
            leitor = new BufferedReader(byte_para_char);
            char_unicode = leitor.read();
            if (char_unicode == 0xFEFF) {
                char_unicode = leitor.read();
            }
            do {
                // processando letra maiuscula e sua primeira variante minuscula
                maiuscula = String.valueOf((char) char_unicode);
                alfabeto.put(maiuscula, maiuscula);
                char_unicode = leitor.read();
                if (char_unicode != -1 && char_unicode != '\r' && char_unicode != '\n') {
                    minuscula = String.valueOf((char) char_unicode);
                    alfabeto_maiusculo.put(maiuscula, minuscula); // so entra as letras que possuem versao minuscula
                    alfabeto_minusculo.put(minuscula, maiuscula);
                    alfabeto.put(minuscula, minuscula);
                    char_unicode = leitor.read();
                }
                // processando demais variantes minusculas ate o fim da linha
                while (char_unicode != '\n' && char_unicode != -1) {
                    char_unicode = leitor.read();
                    if (char_unicode == '\r' || char_unicode == '\n' || char_unicode == -1) {
                        continue;
                    }
                    minuscula = String.valueOf((char) char_unicode);
                    alfabeto_minusculo.put(minuscula, maiuscula); // alfabeto de minusculas
                    alfabeto.put(minuscula, minuscula);
                }
                char_unicode = leitor.read();
            } while (char_unicode !=-1);
            leitor.close();
        } catch (IOException e) {
            e.printStackTrace();
            return false;
        }
        return true;
    }


    public boolean conta_sentencas() {
        //
        // faz uma estimativa do número de sentencas do documento
        //
        Hashtable<String, String> letras = new Hashtable<String, String>();
        Hashtable<String, String> maiusculas = new Hashtable<String, String>();
        Hashtable<String, String> minusculas = new Hashtable<String, String>();
        String arquivo_alfabeto = "/home/arnaldo/projetos/dhpb/corpus/unitex/Alphabet.txt";
        if (! carrega_alfabeto(arquivo_alfabeto, letras, maiusculas, minusculas)) {
            mensageiro.erro("Erro abrindo " + arquivo_alfabeto);
            return false;
        }
        int total_sentencas = 1; // a primeira e a ultima
        editor.move_inicio();
        while (editor.encontra_caracter(1, ".")) {
            editor.move(1);
            editor.encontra_naobranco(1, false);
            if (maiusculas.containsKey(editor.le_caracter())) {
                total_sentencas++;
            }
        }
        mensageiro.status(Integer.toString(total_sentencas) + " sentenças");
        return true;
    }
    
    public boolean converte_notas_alfabeticas() {
        //
        // converte notas no formato alfabetico (a, b, c)
        //
        int chamadas_processadas = 0;
        int notas_processadas = 0;
        char[] token_lido;
        mensageiro.status("Convertendo notas alfabéticas...");
        // passo 1: processando chamadas
        editor.move_inicio();
        while (editor.encontra_token(1, "^", "marcadorderodape")) {
            if (editor.le_token().equals("marcadorderodape")) {
                editor.encontra_token(1, "marcadordepagina");
                continue;
            }
            editor.move(1);
            editor.encontra_naobranco(1);
            token_lido = editor.le_token().toLowerCase().toCharArray();
            if (token_lido.length == 1 && token_lido[0] >= 'a' && token_lido[0] <= 'z') {
                editor.remove(1);
                editor.insere_esquerda(Integer.toString(token_lido[0] - 'a' + 1));
                chamadas_processadas++;
            }
        }
        // passo 2: processando rodapés
        editor.move_inicio();
        editor.encontra_token(1, "marcadorderodape"); // posiciona no primeiro rodapé
        while (editor.encontra_token(1, "\n", "marcadorderodape", "marcadordepagina")) {
            if (editor.le_token().equals("marcadordepagina")) {
                editor.encontra_token(1, "marcadorderodape");
                continue;
            }
            if (editor.move_token(1) != 1) {
                break;
            }
            editor.encontra_naobranco(1);
            if (editor.le_caracter().equals("^")) {
                editor.remove(1);
                editor.encontra_naobranco(1);
            }
            token_lido = editor.le_token().toLowerCase().toCharArray();
            if (token_lido.length == 1 && token_lido[0] >= 'a' && token_lido[0] <= 'z') {
                editor.remove(1);
                editor.insere_esquerda(Integer.toString(token_lido[0] - 'a' + 1));
                notas_processadas++;
            }
        }
        mensageiro.status(Integer.toString(chamadas_processadas) + " chamadas processadas, " 
                + Integer.toString(notas_processadas) + " notas processadas");
        return true;
    }
    
    public boolean converte_notas_asteriscos() {
        //
        // converte notas com asteriscos
        //
        int notas_convertidas = 0;
        int posicao_inicial;
        int total_asteriscos;
        mensageiro.status("Convertendo notas com asteriscos...");
        editor.move_inicio();
        while (editor.encontra_caracter(1, "(")) {
            posicao_inicial = editor.le_posicao();
            editor.move(1);
            editor.encontra_naobranco(1);
            total_asteriscos = 0;
            while (editor.le_caracter().equals("*")) {
                total_asteriscos++;
                editor.move(1);
            }
            editor.encontra_naobranco(1);
            if (editor.le_caracter().equals(")") && total_asteriscos > 0) {
                editor.remove(posicao_inicial, editor.le_posicao()+1);
                editor.insere_esquerda("(" + Integer.toString(total_asteriscos) + ")");
                notas_convertidas++;
            }
        }
        mensageiro.status(Integer.toString(notas_convertidas) + " notas convertidas");
        return true;
    }
    
    public boolean converte_notas_multipaginas() {
        //
        // verifica última numeracao marginal do documento
        //
        int j;
        int posicao_inicial;
        int posicao_final;
        int posicao_insercao;
        String texto_recortado;
        String token_lido;
        editor.move_inicio();
        mensageiro.status("Convertendo notas que ocupam múltiplas páginas...");
        while (editor.encontra_token(1, "marcadorderodape")) {
            editor.move_token(1);
            editor.encontra_naobranco(1, false);
            if (editor.le_token().equals("^")) {
                editor.remove_token(1);
                editor.encontra_naobranco(1);
            }
            token_lido = editor.le_token();
            if (editor.le_natural()== -1 && ! token_lido.equals("marcadordepagina") && ! token_lido.equals("marcadorderodape")) {
                posicao_inicial = editor.le_posicao();
                this.encontra_proxima_nota();
                posicao_final = editor.le_posicao();
                editor.move(-1);
                if (editor.encontra_token(-1, "marcadordepagina")) {
                    posicao_insercao = editor.le_posicao();
                    texto_recortado = editor.le_caracter(posicao_inicial, posicao_final) + " ";
                    editor.remove(posicao_inicial, posicao_final);
                    editor.move_para_posicao(posicao_insercao);
                    editor.insere_direita(texto_recortado);
                    mensageiro.status("1 conversão realizada - é necessário verificar o resultado na posição do cursor");
                    return false; // usuário precisa analisar resultado
                } else {
                    editor.move_para_posicao(posicao_inicial);
                    mensageiro.erro("Erro: não foi possível converter a nota na posição do cursor");
                    return false;
                }
            }
        }
        mensageiro.status("Nenhuma nota multipágina encontrada");
        return false;
    }
        
    public boolean converte_notas_parenteses() {
        //
        // converte notas entre parenteses para notas em sobrescrito
        //
        int chamadas_processadas = 0;
        int numero_lido;
        int posicao_inicial;
        String token_lido;
        int rodapes_processados = 0;
        // passo 1: processar chamados
        mensageiro.status("Convertando notas entre parenteses (chamadas)...");
        editor.move_inicio();
        while(editor.encontra_token(1, "(", "marcadorderodape")) {
            if (editor.le_token().equals("marcadorderodape")) {
                editor.encontra_token(1, "marcadordepagina");
                continue;
            }
            posicao_inicial = editor.le_posicao();
            editor.move_token(1);
            editor.encontra_naobranco(1);
            if (editor.le_token().equals("^")) {
                editor.move_token(1);
                editor.encontra_naobranco(1);
            }
            numero_lido = this.le_natural_i();
            if (numero_lido == -1) {
                continue;
            }
            if (editor.le_natural() == -1) {
                editor.move_token(1);
            } else {
                editor.move_natural(1);
            }
            editor.encontra_naobranco(1);
            if (! editor.le_caracter().equals(")")) {
                continue;
            }
            editor.remove(posicao_inicial, editor.le_posicao() + 1);
            editor.move_para_posicao(posicao_inicial);
            editor.insere_esquerda("^" + Integer.toString(numero_lido));
            chamadas_processadas++;
        }
        // passo 2: processar notas
        mensageiro.status("Convertando notas entre parenteses (rodapés)...");
        editor.move_inicio();
        while (editor.encontra_token(1, "(", "marcadordepagina")) {
            if (editor.le_token().equals("marcadordepagina")) {
                editor.encontra_token(1, "marcadorderodape");
                continue;
            }
            posicao_inicial = editor.le_posicao();
            // verificando se nota está no início da linha
            editor.move(-1); 
            editor.encontra_naobranco(-1);
            token_lido = editor.le_token();
            editor.move_para_posicao(posicao_inicial);
            if (! token_lido.equals("marcadorderodape") && ! token_lido.equals("\n")) {
                editor.move(1);
                continue;
            }
            // lendo número
            editor.move(1);
            editor.encontra_naobranco(1);
            numero_lido = this.le_natural_i();
            if (numero_lido == -1) {
                continue;
            }
            if (editor.le_natural() == -1) {
                editor.move_token(1);
            } else {
                editor.move_natural(1);
            }
            // lendo fecha parenteses
            editor.encontra_naobranco(1);
            if (! editor.le_caracter().equals(")")) {
                continue;
            }
            // convertendo
            editor.remove(posicao_inicial, editor.le_posicao() + 1);
            editor.move_para_posicao(posicao_inicial);
            editor.insere_esquerda(Integer.toString(numero_lido));
            rodapes_processados++;
        }
        mensageiro.status(Integer.toString(chamadas_processadas) + " chamadas convertidas, " + Integer.toString(rodapes_processados) + " rodapes processados");
        return true;
    }
   
    public boolean cria_dicionario_abreviaturas() {
        //
        // cria um dicionário no formato dela a partir de uma lista de abreviaturas
        //
        String abreviatura;
        String entrada_dela;
        String expansao;
        int posicao_inicial;
        int posicao_parenteses;
        int posicao_traco;
        String seculo;
        mensageiro.status("Criando dicionário...");
        //mensageiro.aviso(Integer.toHexString((int) editor.le_caracter(1).toCharArray()[0]));
        // verificando estrutura
        editor.move_inicio();
        do {
            // lendo abreviatura
            editor.encontra_caracter(1, "-", "\u2013", "\u002D", "\n"); // dois traços parecidos
            if (! (editor.le_caracter().equals("-") || editor.le_caracter().equals("\u2013"))) {
                mensageiro.erro("Erro1: formato inválido");
                return false;
            }
            // lendo forma expandida
            editor.encontra_caracter(1, "(", "\n");
            if (! editor.le_caracter().equals("(")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            // lendo século
            editor.encontra_caracter(1, ")", "\n");
            if (! editor.le_caracter().equals(")")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            editor.encontra_caracter(1, "\n");
        } while (editor.move(1) == 1);
        // tratando pontos
        editor.move_inicio();
        do {
            if (editor.encontra_caracter(1, ".")) {
                editor.insere_esquerda("\\");
            }
        } while (editor.move(1) == 1);
        // gerando entrada no formato do dicionário
        editor.move_inicio();
        do {
            // lendo abreviatura
            posicao_inicial = editor.le_posicao();
            editor.encontra_caracter(1, "-", "\u2013", "\n"); // dois traços parecidos
            if (! (editor.le_caracter().equals("-") || editor.le_caracter().equals("\u2013"))) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            posicao_traco = editor.le_posicao();
            abreviatura = editor.le_caracter(posicao_inicial, posicao_traco);
            // lendo forma expandida
            editor.encontra_caracter(1, "(", "\n");
            if (! editor.le_caracter().equals("(")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            posicao_parenteses = editor.le_posicao();
            expansao = editor.le_caracter(posicao_traco + 1, posicao_parenteses);
            // lendo século
            editor.encontra_caracter(1, ")", "\n");
            if (! editor.le_caracter().equals(")")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            seculo = editor.le_caracter(posicao_parenteses + 1, editor.le_posicao());
            // deletando linha antiga e inserindo entrada dela
            editor.encontra_caracter(1, "\n");
            editor.remove(posicao_inicial, editor.le_posicao());
            entrada_dela = abreviatura.trim() + "," + expansao.trim() + ".N+ABREV:ms" + "/sec" + seculo.trim();
            editor.insere_esquerda(entrada_dela);
        } while (editor.move(1) == 1);
        mensageiro.status("dicionário criado com sucesso");
        return true;
    }

    public boolean cria_dicionario_grafias() {
        //
        // gera dicionario de variaçoes ortograficas a partir da saida do Siaconf
        //
        Date data;
        String canonica;
        String comentario = "";
        boolean inverter = true;
        float ocorrencias_variante;
        float percentual_ocorrencia;
        int posicao_inicial;
        float total_ocorrencias;
        long ultima_data = 0;
        StringBuilder dicionario = new StringBuilder();
        String variante;
        mensageiro.status("Gerando dicionario de variaçoes ortograficas");
        editor.move_inicio();
        canonica = editor.le_token();
        dicionario.append("");
        // lendo todas as canônicas
        while (! canonica.equals("\n") && ! canonica.equals("")) {
            posicao_inicial = editor.le_posicao();
            // le uma canonica
            canonica = editor.le_token().toLowerCase();
            // lendo total de ocorrencias da canonica e suas variantes
            editor.encontra_caracter(1, "(", "\n");
            if (editor.le_caracter().equals("(")) {
                editor.move(1);
                total_ocorrencias = editor.le_natural();
                editor.encontra_caracter(1, "\n");
            } else {
                total_ocorrencias = -1;
            }
            editor.move(1);
            // lendo todas as variantes
            while (editor.le_caracter().equals("\t")) {
                // le uma variante
                posicao_inicial = editor.le_posicao();
                editor.move(1);
                variante = editor.le_token().toLowerCase();
                // lendo total de ocorrencias da variante
                editor.encontra_caracter(1, "(", "\n");
                if (editor.le_caracter().equals("(")) {
                    editor.move(1);
                    ocorrencias_variante = editor.le_natural();
                    editor.encontra_caracter(1, "\n");
                } else {
                    ocorrencias_variante = -1;
                }
                // calculando percentual da variante
                if (total_ocorrencias == -1 || total_ocorrencias == 0) {
                    comentario = "";
                } else if (ocorrencias_variante == -1) {
                    comentario = "/0%";
                } else {
                    percentual_ocorrencia = (ocorrencias_variante*100)/total_ocorrencias;
                    percentual_ocorrencia = (int) (percentual_ocorrencia * 100); // gambiarra para ter duas casas decimais
                    percentual_ocorrencia /= 100;
                    comentario = "/" + Float.toString(percentual_ocorrencia) + "%";
                }
                // computando entrada dela
                if (inverter) {
                    dicionario.append(canonica + "," + variante + ".N+VAR:ms" + comentario + "\n");
                } else {
                    dicionario.append(variante + "," + canonica + ".N+VAR:ms" + comentario + "\n");
                }
                data = new java.util.Date();
                if (data.getTime() - ultima_data > 2000) {
                    mensageiro.status("canonica " + canonica + ", variante " + variante);
                    ultima_data = data.getTime();
                }
                editor.encontra_caracter(1, "\n");
                editor.move(1);
            }
            editor.encontra_naobranco(1, false);
            canonica = editor.le_token();
        }
        editor.remove(0, editor.le_posicao());
        editor.insere_esquerda(dicionario.toString());
        mensageiro.status  ("Dicionario gerado com sucesso");
        return true;
        
    }
            
    public boolean cria_planilha() {
        //
        // gera um arquivo para importaçao no excel, ao inves de um dicionario
        //
        mensageiro.status("Validando arquivo de entrada...");
        // passo 0: verificando sintaxe do formato de origem
        editor.move_inicio();
        do {
            // lendo abreviatura
            editor.encontra_caracter(1, "-", "\u2013", "\u002D", "\n"); // dois traços parecidos
            if (! (editor.le_caracter().equals("-") || editor.le_caracter().equals("\u2013"))) {
                mensageiro.erro("Erro1: formato inválido");
                return false;
            }
            // lendo forma expandida
            editor.encontra_caracter(1, "(", "\n");
            if (! editor.le_caracter().equals("(")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            // lendo século
            editor.encontra_caracter(1, ")", "\n");
            if (! editor.le_caracter().equals(")")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            editor.encontra_caracter(1, "\n");
        } while (editor.move(1) == 1);

        mensageiro.status("Convertendo formato");
        // passo 1: gerando formato alvo
                editor.move_inicio();
        do {
            // lendo abreviatura
            editor.encontra_caracter(1, "-", "\u2013", "\n"); // dois traços parecidos
            if (! (editor.le_caracter().equals("-") || editor.le_caracter().equals("\u2013"))) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            editor.remove(1);
            editor.insere_esquerda("\t");
            // lendo forma expandida
            editor.encontra_caracter(1, "(", "\n");
            if (! editor.le_caracter().equals("(")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            editor.remove(1);
            editor.insere_esquerda("\t");
            // lendo século(s)
            editor.encontra_caracter(1, ")", "\n");
            if (! editor.le_caracter().equals(")")) {
                mensageiro.erro("Erro: formato inválido");
                return false;
            }
            editor.remove(1);
            editor.insere_esquerda("\t");
            editor.encontra_caracter(1, "\n");
        } while (editor.move(1) == 1);
        mensageiro.status("Formato de planilha criado com sucesso");
        return true;
    }
    
    public String diretorio_pai(String nome_arquivo) {
        //
        // retorna o diretorio pai de um arquivo
        //
        int posicao_final;
        posicao_final = nome_arquivo.lastIndexOf(File.separator);
        if (posicao_final < 0) {
            return "";
        }
        return nome_arquivo.substring(0, posicao_final);
    }
    
    
    private String encontra_dado_catalografico(int item) {
        //
        // encontra o item especificado na ficha ou retorna String vazia em caso de falha
        //
        int posicao_inicial;
        while (editor.encontra_token(1, "\n")) {
            if (editor.move(1) != 1) {
                return "";
            }
            editor.encontra_naobranco(1);
            if (editor.le_natural() == item) {
                break;
            }
        }
        editor.encontra_caracter(1, ":", "\n");
        if (editor.le_caracter().equals("\n")) {
            return "";
        }
        editor.move(1);
        posicao_inicial = editor.le_posicao();
        editor.encontra_caracter(1, ":", "\n"); // pode haver dois ":" no texto
        if (editor.le_caracter().equals(":")) {
            editor.move(1);
            posicao_inicial = editor.le_posicao();
            editor.encontra_caracter(1, "\n");
        } 
        editor.move(-1);
        editor.encontra_naobranco(-1);
        editor.move(1);
        return editor.le_caracter(posicao_inicial, editor.le_posicao());
    }
    
    private String encontra_dado_xml(String dado) {
        //
        // retorna o valor de uma tag se ela estiver presente no arquivo
        // retorna string vazia caso contrario
        //
        int posicao_inicial = -1;
        int posicao_final = -1;
        editor.move_inicio();
        if (editor.encontra_texto(1, "<" + dado + ">")) {
            editor.encontra_caracter(1, ">");
            editor.move(1);
            posicao_inicial = editor.le_posicao();
            if (editor.encontra_texto(1, "</" + dado + ">")) {
                return editor.le_caracter(posicao_inicial, editor.le_posicao());
            }
        }
        return "";
    }
    
    private boolean encontra_proxima_nota() {
        //
        // encontra a próxima nota (rodapé sucedido por número ou \n sucedido por número)
        // supÃµe-se que a região já seja rodapé quando próximo token não é marcador de rodapé
        //
        int posicao_circunflexo;
        String token_lido;
        while (editor.encontra_token(1, "\n", "marcadorderodape", "marcadordepagina")) {
            if (editor.le_token().equals("marcadordepagina") || editor.move_token(1) != 1) {
                return false;
            }
            editor.encontra_naobranco(1);
            posicao_circunflexo = -1;
            if (editor.le_caracter().equals("^")) {
                posicao_circunflexo = editor.le_posicao();
                editor.move(1);
                editor.encontra_naobranco(1);
            }
            if (editor.le_natural() != -1) {
                if (posicao_circunflexo != -1) {
                    editor.move_para_posicao(posicao_circunflexo);
                }
                return true;
            }
        }
        return false;
    }
    
    private boolean encontra_token_sem_xml(int direcao, String... tokens) {
        //
        // semelhante a encontra token, mas ignora XML
        // não procura para trás e passagem de maior como parâmetro é obrigatória
        //
        if (direcao < 0) {
            mensageiro.aviso("Recurso não implementado: encontrar token sem xml voltando");
        }
        direcao = 1;
        while (editor.encontra_token(direcao, tokens)) {
            if (editor.le_token().equals("<")) {
                this.ignora_xml();
            } else {
                return true;
            }
        }
        return false;
    }
  
    public boolean etiqueta_notas_linhas() {
        //
        // lê notas que referenciam linhas no fim do documento e insere em formato xml no corpo do texto
        //
        int fim_pagina;
        int i, j;
        String nota_recortada;
        String nota_convertida;
        int notas_processadas = 0;
        String numeracao_posterior;
        String numeracao_anterior;
        int numero_nota;
        int palavras_lidas;
        int posicao_insercao;
        int posicao_nota;
        int posicao_numeracao_anterior;
        String token_lido;
        editor.move_inicio();
        while (editor.encontra_token(1, "marcadorderodape")) {
            while (this.encontra_proxima_nota()) {
                // passo 0: posição e número da nota a ser recortada
                numero_nota = editor.le_natural();
                posicao_nota = editor.le_posicao();
                // passo 1: determinando posicao da numeração anterior (múltiplo de 5)
                numeracao_anterior = Integer.toString(numero_nota - (numero_nota % 5));
                numeracao_posterior = Integer.toString(Integer.parseInt(numeracao_anterior) + 5);
                if (numeracao_anterior.equals("0")) {
                    numeracao_anterior = "5";
                }
                editor.encontra_token(-1, "marcadordepagina");
                editor.move_token(1);
                this.encontra_token_sem_xml(1, numeracao_anterior, "marcadordepagina", "marcadorderodape");
                if (! editor.le_token().equals(numeracao_anterior)) {
                    editor.encontra_token(-1, "marcadordepagina");
                    editor.move_token(-1);
                    editor.encontra_token(-1, "marcadordepagina");
                    editor.move_token(1);
                    this.encontra_token_sem_xml(1, numeracao_anterior, "marcadordepagina", "marcadorderodape");
                }
                if (! editor.le_token().equals(numeracao_anterior)) {
                    editor.move_para_posicao(posicao_nota);
                    mensageiro.erro("Erro: posição de inserção indefinida (numeração " + numeracao_anterior + " não encontrada)");
                    return false;
                }
                posicao_numeracao_anterior = editor.le_posicao();
                // passo 2: encontrado posição de inserção
                if (! numeracao_posterior.equals("5")) { // evitando numeração anterior = 0
                    palavras_lidas = 0;
                    token_lido = "";
                    while (editor.move_token(1) == 1) {
                        this.ignora_xml();
                        token_lido = editor.le_token();
                        // nota: testar marcadordepagina não é necessário no if abaixo, mesmo quando na página anterior
                        if (token_lido.equals(numeracao_posterior) || token_lido.equals("marcadorderodape")) {
                            break;
                        }
                        palavras_lidas++;
                    } 
                    if (token_lido.equals(numeracao_posterior)) {
                        palavras_lidas = (palavras_lidas / 5) * ((numero_nota % 5) + 1);
                    }
                    editor.move_para_posicao(posicao_numeracao_anterior);
                    i = 0;
                    while (editor.move_token(1) == 1 && i < palavras_lidas) {
                        this.ignora_xml();
                        i++;
                    }
                }
                posicao_insercao = editor.le_posicao();
                // passo 3: recortando e inserindo
                editor.move_para_posicao(posicao_nota);
                editor.remove_natural();
                editor.encontra_token(1, "marcadordepagina", "marcadorderodape");
                fim_pagina = editor.le_posicao();
                editor.move_para_posicao(posicao_nota);
                this.encontra_proxima_nota();
                if (editor.le_posicao() < fim_pagina) {
                    fim_pagina = editor.le_posicao();
                }
                nota_recortada = editor.le_caracter(posicao_nota, fim_pagina);
                editor.remove(posicao_nota, fim_pagina);
                editor.move_para_posicao(posicao_insercao);
                nota_convertida = " <note place= \"foot\" n=\"" + Integer.toString(numero_nota) +  "\" type=\"line\"> ";
                nota_convertida += nota_recortada + "</note> ";
                editor.insere_esquerda(nota_convertida);
                notas_processadas++;
                // voltando a posição original (não tem problema se for rodapé da página anterior)
                editor.encontra_token(1, "marcadorderodape", "marcadordepagina");
            }
        }
        mensageiro.status(Integer.toString(notas_processadas) + " notas convertidas");
        return true;
    }
        
    public boolean etiqueta_notas_palavras() {
        //
        // lê notas que referenciam palavras no fim do página e insere em formato xml no corpo do texto
        // 
        boolean achou_nota;
        int chamada;
        int inicio_chamada;
        int inicio_nota;
        int fim_chamada;
        int fim_nota;
        String nota_convertida;
        int notas_processadas = 0;
        String nota_recortada;
        int posicao_rodape = 0;
        String token_lido;
        mensageiro.status("Convertendo notas que referenciam palavras para XML...");
        editor.move_inicio();
        while (editor.encontra_token(1, "^", "marcadorderodape")) {
            // passo 1: encontrando chamada
            if (editor.le_token().equals("marcadorderodape")) {
                editor.encontra_token(1, "marcadordepagina");
                continue;
            }
            inicio_chamada = editor.le_posicao();
            editor.move(1);
            editor.encontra_naobranco(1);
            chamada = editor.le_natural();
            if (chamada == -1) {
                continue;
            }
            editor.move_natural(1);
            fim_chamada = editor.le_posicao();
            // passo 2: encontrando nota (usar o segundo marcador de rodapé se existir)
            if (this.etiquetar_notas_fim_pagina) {
                editor.encontra_token(1, "marcadorderodape", "marcadordepagina");
                token_lido = editor.le_token();
                if (! token_lido.equals("marcadorderodape")) {
                    editor.move_para_posicao(inicio_chamada);
                    mensageiro.erro("Erro: chamada sem nota na posição do cursor");
                    return false;
                }
                posicao_rodape = editor.le_posicao();
                editor.move_token(1);
                editor.encontra_token(1, "marcadorderodape", "marcadordepagina");
                if (! editor.le_token().equals("marcadorderodape")) {
                    editor.move_para_posicao(posicao_rodape);
                }
            } else {
                editor.move_para_posicao(editor.le_tamanho_texto());
                if (! editor.encontra_texto(-1, "marcadorderodape")) {
                    mensageiro.erro("Erro: texto sem marcador de rodapé");
                    return false;
                }
                editor.move_token(1);
            }
            achou_nota = false;
            while (this.encontra_proxima_nota()) {
                if (editor.le_caracter().equals("^")) {
                    editor.remove(1);
                    editor.encontra_naobranco(1);
                }
                if (editor.le_natural() == chamada) {
                    achou_nota = true;
                    break;
                }
            }
            if (! achou_nota) {
                editor.move_para_posicao(inicio_chamada);
                mensageiro.erro("Erro: chamada sem nota na posição do cursor");
                return false;
            }
            // passo 3: recortando e inserindo
            editor.remove_natural();
            inicio_nota = editor.le_posicao();
            this.encontra_proxima_nota();
            fim_nota = editor.le_posicao();
            nota_recortada = editor.le_caracter(inicio_nota, fim_nota);
            editor.remove(inicio_nota, fim_nota);
            editor.remove(inicio_chamada, fim_chamada);
            editor.move_para_posicao(inicio_chamada);
            nota_convertida = " <note place= \"foot\" n=\"" + Integer.toString(chamada) +  "\">";
            nota_convertida += nota_recortada + "</note> ";
            editor.insere_esquerda(nota_convertida);
            notas_processadas++;
        }
        mensageiro.status(Integer.toString(notas_processadas) + " notas convertidas");
        this.encontra_proxima_nota();
        return true;
    }

    public boolean etiqueta_notas_palavras_documento() {
        //
        // lê notas que referenciam palavras no fim do documento e insere em formato xml no corpo do texto
        //
        boolean achou_nota = false;
        int chamada;
        int posicao_rodape;
        int posicao_chamada;
        mensageiro.status("Convertendo notas que referenciam palavras para XML...");
        editor.move_para_posicao(editor.le_tamanho_texto());
        // descobrindo posição do último rodapé do texto
        if (! editor.encontra_texto(-1, "marcadorderodape")) {
            mensageiro.erro("Erro: texto sem marcador de rodapé");
            return false;
        }
        editor.move_token(1);
        posicao_rodape = editor.le_posicao();
        // processando notas
        editor.move_inicio();
        while (editor.encontra_token(1, "^", "marcadorderodape")) {
            // passo 1: lendo chamada
            if (editor.le_token().equals("marcadorderodape")) {
                break;
            }
            posicao_chamada = editor.le_posicao();
            editor.move(1);
            editor.encontra_naobranco(1);
            chamada = editor.le_natural();
            if (chamada == -1) {
                continue;
            }
            // passo 2: encontrando nota correspondente
            editor.move_para_posicao(posicao_rodape);
            achou_nota = false;
            while (this.encontra_proxima_nota()) {
                if (editor.le_natural() == chamada) {
                    achou_nota = true;
                    break;
                }
            }
            if (! achou_nota) {
                editor.move_para_posicao(posicao_chamada);
                mensageiro.erro("Erro: chamada sem nota na posição do cursor");
                return false;
            }
            break;
        }
           
        return true;
    }
    
    public boolean etiqueta_numeracao_paginas() {
        //
        // etiqueta a primeira ou a última linha do documento com tags Unitex
        // 
        if (this.etiquetar_primeira_linha) {
            return this.etiqueta_primeira_linha();
        } else {
            return this.etiqueta_ultima_linha();
        }
    }
    
    public boolean etiqueta_primeira_linha() {
        //
        // etiqueta a primeira linha do documento com tags Unitex
        // 
        boolean achou_numero;
        boolean encontrou_marcador = false;
        int posicao_inicial;
        int posicao_final;
        int total_etiquetado = 0;
        String texto_adicional;
        mensageiro.status("Etiquetando numeração de páginas (primeira linha)");
        editor.move_inicio();
        editor.encontra_naobranco(1, false);
        // etiquetando
        do {
            if (editor.le_token().equals("marcadordepagina")) { // primeira página geralmente não tem
                editor.move_token(1);
            }
            if (! editor.encontra_naobranco(1, false)) {
                break;
            }
            posicao_inicial = editor.le_posicao();
            // pular páginas já etiquetadas
            if (editor.le_caracter().equals("{")) {
                continue;
            }
            // verificar se a numeração da página começa no início da linha
            achou_numero = false;
            if (editor.le_natural() != -1) {
                achou_numero = true;
            } else {
                editor.move_token(1);
                editor.encontra_naobranco(1);
                if (editor.le_natural() != -1) {
                    achou_numero = true;
                }
                editor.move_para_posicao(posicao_inicial);
            }
            // encontrar fim da linha
            editor.encontra_token(1, "\n", "marcadordepagina");
            editor.move_token(-1);
            editor.encontra_naobranco(-1);
            // verificar se a numeração está no início ou no fim
            if (editor.le_natural() == -1 && ! achou_numero) {
                editor.move_para_posicao(posicao_inicial);
                mensageiro.erro("Erro: número da página não detectado");
                return false;
            }
            // inserindo chaves
            editor.move_token(1);
            posicao_final = editor.le_posicao() + 1;
            editor.insere_esquerda(",.N}");
            editor.move_para_posicao(posicao_inicial);
            editor.insere_esquerda("{");
            if (this.incluir_arquivo_etiqueta_paginas) {
                texto_adicional = this.calcula_texto_adicional() + " - ";
                editor.insere_esquerda(texto_adicional);
                posicao_final = posicao_final + texto_adicional.length();
            }
            do  {
                if (editor.le_caracter().equals("\t")) {
                    editor.remove(1);
                    editor.insere_direita(" ");
                }
            } while (editor.le_posicao() != posicao_final && editor.move(1) == 1);
            total_etiquetado++;
        } while (editor.encontra_token(1, "marcadordepagina"));
        mensageiro.status(Integer.toString(total_etiquetado) + " etiquetas inseridas");
        return true;
    }

    public boolean etiqueta_ultima_linha() {
        //
        // etiqueta a ultima linha do documento com tags Unitex
        // 
        boolean achou_numero;
        boolean encontrou_marcador = false;
        int posicao_final;
        int posicao_final_linha;
        int posicao_inicial;
        int posicao_inicial_linha;
        String texto_adicional;
        String texto_recortado;
        int total_etiquetado = 0;
        mensageiro.status("Etiquetando numeração de páginas (última linha)");
        editor.move_inicio();
        editor.encontra_naobranco(1, false);
        // etiquetando
        do {
            if (editor.le_token().equals("marcadordepagina")) { // primeira página geralmente não tem
                editor.move_token(1);
            }
            if (! editor.encontra_naobranco(1, false)) {
                break;
            }
            posicao_inicial = editor.le_posicao();
            // pular páginas já etiquetadas
            if (editor.le_caracter().equals("{")) {
                continue;
            }
            // posicionar no fim da última linha e verificar numeração
            editor.encontra_token(1, "marcadordepagina");
            editor.move(-1);
            editor.encontra_naobranco(-1, false);
            achou_numero = false;
            if (editor.le_natural() != -1) {
                achou_numero = true;
            }
            posicao_final_linha = editor.le_posicao() + 1;
            // encontrar início da linha da linha
            editor.encontra_token(-1, "\n", "marcadordepagina");
            editor.move_token(1);
            editor.encontra_naobranco(1);
            posicao_inicial_linha = editor.le_posicao();
            // verificar se a numeração está no inicio ou no fim
            if (editor.le_natural() == -1 && ! achou_numero) {
                editor.move_token(1);
                editor.encontra_naobranco(1);
                if (editor.le_natural() == -1) {
                    mensageiro.erro("Erro: número da página não detectado");
                    return false;
                }
                editor.move_para_posicao(posicao_inicial_linha);
            }
            // recortando texto e inserindo chaves
            posicao_inicial_linha = editor.le_posicao();
            texto_recortado = editor.le_caracter(posicao_inicial_linha, posicao_final_linha);
            editor.remove(posicao_inicial_linha, posicao_final_linha);
            editor.move_para_posicao(posicao_inicial);
            editor.insere_esquerda("{");
            if (this.incluir_arquivo_etiqueta_paginas) {
                texto_adicional = this.calcula_texto_adicional() + " - ";
                editor.insere_esquerda(texto_adicional);
            }
            editor.insere_esquerda(texto_recortado + ",.N}\n");
            posicao_final = editor.le_posicao();
            editor.move_para_posicao(posicao_inicial);
            do  {
                if (editor.le_caracter().equals("\t")) {
                    editor.remove(1);
                    editor.insere_direita(" ");
                }
            } while (editor.le_posicao() != posicao_final && editor.move(1) == 1);
            total_etiquetado++;
        } while (editor.encontra_token(1, "marcadordepagina"));
        mensageiro.status(Integer.toString(total_etiquetado) + " etiquetas inseridas");
        return true;
    }

    private String extrai_ano(String valor) {
        //
        // extraí a primeira sequência de 4 digitos de uma string
        // se houver outra sequência, esta também será extraída
        //
        String ano_inicio = "";
        String ano_fim = "";
        String aux = "";
        int i;
        char[] valor_char = valor.toCharArray();
        for (i=0; i<valor_char.length; i++) {
            if (valor_char[i] >= '0' && valor_char[i] <= '9') {
                aux += valor_char[i];
                if (aux.length() == 4) {
                    if (ano_inicio.equals("")) {
                        ano_inicio = aux;
                    } else {
                        ano_fim = aux;
                        return ano_inicio + "-" + ano_fim;
                    }
                }
            } else {
                aux = "";
            }
        }
        if (ano_inicio.equals("")) {
            ano_inicio = "????";
        }
        return ano_inicio;
    }
    
    private ficha_catalografica extrai_ficha_catalografica() {
        //
        // preenche informaçoes sobre a ficha catalografica a partir do arquivo aberto
        //
        ficha_catalografica ficha = new ficha_catalografica();
        mensageiro.status("Extraindo ficha catalográfica...");
        editor.move_inicio();
        ficha.autor = encontra_dado_catalografico(6);
        ficha.titulo = encontra_dado_catalografico(7);
        ficha.data_autor = encontra_dado_catalografico(8);
        ficha.data_edicao = encontra_dado_catalografico(15);
        ficha.data_publicacao = "2006-2007";
        if (ficha.autor.equals("")) {
            ficha.autor = "desconhecido";
        }
        if (ficha.titulo.equals("")) {
            ficha.titulo = encontra_dado_catalografico(10);
            if (ficha.titulo.equals("")) {
                ficha.titulo = "em branco";
            }
        }
        mensageiro.status("Ficha extraida");
        return ficha;
    }
    
    public boolean gera_cabecalho_procorph() {
        //
        // gera um arquivo sql para inserir o cabeçalho dos textos no bd do
        // procorph
        //
        String alvo;
        String arquivo_alfabeto;
        String[] arquivos;
        FileOutputStream destino;
        String diretorio_fichas;
        String diretorio_unitex;
        Writer escritor;
        ficha_catalografica ficha;
        int i;
        Hashtable<String, String> letras = new Hashtable<String, String>();
        Hashtable<String, String> maiusculas = new Hashtable<String, String>();
        Hashtable<String, String> minusculas = new Hashtable<String, String>();
        String nome_curto;
        String nome_novo;
        String sql = "";
        // preparando
        mensageiro.status("Gerando cabeçalho versão Procorph...");
        if (diretorios_origem == null || diretorios_origem.length == 0) {
            mensageiro.status("Erro: diretórios de origem não informados");
            return false;
        }
        diretorio_unitex = diretorios_origem[0].getParent() + File.separator + "unitex";
        arquivo_alfabeto = diretorio_unitex + File.separator + "Alphabet.txt";
        if (! carrega_alfabeto(arquivo_alfabeto, letras, maiusculas, minusculas)) {
            mensageiro.erro("Erro abrindo " + arquivo_alfabeto);
            return false;
        }

        diretorio_fichas = diretorios_origem[0].getParent() + 
                File.separator + "fichas";
        alvo = diretorios_origem[0].getParent() + File.separator
               + "procorph" + File.separator + "cabecalho_procorph.sql";
        arquivos = lista_arquivos(diretorios_origem, ".txt");
        mensageiro.progresso(0, arquivos.length);
        try {
            destino = new FileOutputStream(alvo);
            escritor = new OutputStreamWriter(destino, "UTF-8");
            // varrendo arquivos
            for (i=0; i<arquivos.length; i++) {
                nome_curto = nome_arquivo_sem_diretorio(arquivos[i]);
                mensageiro.status("Processando " + nome_curto);
                // abrindo ficha e extraindo informações
                if (! editor.abre_arquivo(diretorio_fichas + File.separator + nome_curto)) {
                    mensageiro.status("Erro ao abrir ficha " + alvo);
                    continue;
                }
                ficha = extrai_ficha_catalografica();
                editor.fecha_arquivo();
                // salvando informações
                ficha.titulo = normaliza_sql(ficha.titulo, maiusculas);
                ficha.autor = normaliza_sql(ficha.autor, maiusculas);
                ficha.data_autor = normaliza_sql(extrai_ano(ficha.data_autor), maiusculas);
                ficha.data_edicao = normaliza_sql(extrai_ano(ficha.data_edicao), maiusculas);
                nome_novo = nome_curto.substring(0, nome_curto.lastIndexOf("."));
                sql = "insert into texts (name, title, author, creation_year, edition_year)"
                      + " values ('" + nome_novo  + "','" + ficha.titulo + "','"
                      + ficha.autor + "','" + ficha.data_autor + "','"
                      + ficha.data_edicao + "');\n";
                escritor.write(sql);
                mensageiro.progresso(i, arquivos.length);
            }
            escritor.close();
        } catch (IOException e) {
            mensageiro.erro("Erro processando arquivos: " + e.getMessage());
            return false;
        }
        mensageiro.progresso(1,1);
        mensageiro.status("Corpus gerado com sucesso em " + alvo);

        return true;
    }
    
    public boolean gera_corpus_philologic() {
        //
        // tenta converter todos os arquito de um diretorio para o formato do 
        // philologic
        //
        String alvo;
        String[] arquivos;
        int canario = 0;
        String diretorio_fichas;
        String diretorio_philologic;
        ficha_catalografica ficha;
        String erros_abertura_ficha = "";
        String erros_remocao_notas = "";
        boolean modo_teste = false;
        String nome_curto;
        int i;
        // preparativos
        mensageiro.status("Gerando córpus versão Philologic...");
        editor.fecha_arquivo();
        diretorio_philologic = diretorios_origem[0].getParent() + 
                File.separator + "philologic";
        diretorio_fichas = diretorios_origem[0].getParent() + 
                File.separator + "fichas";
        if (diretorios_origem == null || diretorios_origem.length == 0) {
            mensageiro.status("Erro: diretórios de origem não informados");
            return false;
        }
        // varrendo arquivos
        arquivos = lista_arquivos(diretorios_origem, ".txt");
        mensageiro.progresso(0, arquivos.length);
        for (i=0; i<arquivos.length; i++) {
            // abrindo ficha catalográfica
            nome_curto = nome_arquivo_sem_diretorio(arquivos[i]);
            mensageiro.status("Processando " + nome_curto);
            alvo = diretorio_fichas + File.separator + nome_curto;
            if (! editor.abre_arquivo(alvo)) {
                erros_abertura_ficha = erros_abertura_ficha + nome_curto;
                mensageiro.status("Erro ao abrir ficha " + alvo);
                continue;
            }
            // extraindo informações da ficha e fechando
            ficha = extrai_ficha_catalografica();
            editor.fecha_arquivo();
            // processando arquivo atual
            editor.abre_arquivo(arquivos[i]);
            // removendo notas
            if (! remove_notas_xml()){
                erros_remocao_notas = erros_remocao_notas + " " + nome_curto;
            }
            // marcando paragráfos
            insere_marcacao_paragrafo(); 
            // inserindo informações da ficha
            insere_ficha_catalografica(ficha);
            // tudo ok: salvando na pasta do philologic
            alvo = diretorio_philologic + File.separator + nome_curto;
            editor.salva_arquivo(alvo);
            editor.fecha_arquivo();
            if (modo_teste && canario++ > 10) {
                break;
            }
            mensageiro.progresso(i, arquivos.length);
        }
        if (! erros_abertura_ficha.equals("")) {
            mensageiro.status("Problema na abertura das fichas: " + erros_abertura_ficha);
        }
        if (! erros_remocao_notas.equals("")) {
            mensageiro.status("Problema na remoção de notas: " + erros_remocao_notas);
        }
        mensageiro.seta_texto_alterado(false);
        mensageiro.progresso(1,1);
        mensageiro.status("Processo concluido com sucesso");
        return true;        
    }

    public boolean gera_corpus_unitex() {
        //
        // concatena os arquivos do córpus cru e remove as notas
        //
        String alvo;
        String[] arquivos;
        FileOutputStream destino;
        String diretorio_unitex;
        String[] diretorios;
        Writer escritor;
        String falha_remocao_chaves = "";
        String falha_remocao_xml = "";
        int i;
        String nome_curto;
        boolean remover_chaves = false;
        // definindo arquivos e diretórios
        mensageiro.status("Gerando córpus versão Unitex...");
        if (diretorios_origem == null || diretorios_origem.length == 0) {
            mensageiro.status("Erro: diretórios de origem não informados");
            return false;
        }
        editor.fecha_arquivo();
        diretorio_unitex = diretorios_origem[0].getParent() + File.separator + "unitex";
        alvo = diretorio_unitex + File.separator + "corpus_milenio.txt";
        arquivos = lista_arquivos(diretorios_origem, ".txt");
        mensageiro.progresso(0, arquivos.length);
        try {
            destino = new FileOutputStream(alvo);
            escritor = new OutputStreamWriter(destino, "UTF-16LE");
            escritor.write(0xFEFF); // está invertido devido ao uso de little endian
            // varrendo arquivos
            for (i=0; i<arquivos.length; i++) {
                // executando operaõees
                nome_curto = nome_arquivo_sem_diretorio(arquivos[i]);
                mensageiro.status("Processando " + nome_curto);
                editor.abre_arquivo(arquivos[i]);
                if (!this.remove_notas_xml()) {
                    falha_remocao_xml = falha_remocao_xml + " " + nome_curto;
                }
                if (remover_chaves && !this.remove_chaves_unitex()) {
                    falha_remocao_chaves = falha_remocao_chaves + " " + arquivos[i];
                }
                // salvando alterações no txt concatenado
                if (!remover_chaves) {
                    escritor.write("{" + nome_curto + ",.N}");
                }
                escritor.write(editor.converte_para_string());
                // fechando original sem salvar
                editor.fecha_arquivo();
                mensageiro.progresso(i, arquivos.length);
            }
            escritor.close();
        } catch (IOException e) {
            mensageiro.erro("Erro processando arquivos: " + e.getMessage());
            return false;
        }
        mensageiro.seta_texto_alterado(false);
        if (remover_chaves && ! falha_remocao_chaves.equals("")) {
            System.out.println("Falhas em chaves nos seguintes arquivos:" + falha_remocao_chaves);
        }
        if (! falha_remocao_xml.equals("")) {
            mensageiro.status("Falhas em xml nos seguintes arquivos:" + falha_remocao_xml);
        }
        mensageiro.progresso(1,1);
        mensageiro.status("Corpus gerado com sucesso em " + alvo);
        return true;
    }
    
    public boolean gera_corpus_nano_philologic() {
        //
        // processa todos os arquivos do corpus nano e gera versão philologic
        // etiquetas de parágrafo inseridas e algumas etiquetas alteradas
        //
        int arquivo_atual;
        String arquivos[];
        String diretorio_destino;
        String diretorio_origem = "/media/_home/arnaldo/projetos/nano/philologic/antes";
        int posicao_atual;
        boolean tem_erros = false;
        // lendo arquivos e diretórios
        mensageiro.status("Gerando córpus nano");
        editor.fecha_arquivo();
        diretorio_destino = diretorio_pai(diretorio_origem) + File.separator + 
                "depois" + File.separator;
        arquivos = new java.io.File(diretorio_origem).list();
        this.inicio_marcacao_paragrafo = "body";
        // processando arquivos
        for (arquivo_atual = 0; arquivo_atual < arquivos.length; arquivo_atual++) {
            mensageiro.status("Processando: " + arquivos[arquivo_atual]);
            editor.abre_arquivo(diretorio_origem + File.separator + 
                arquivos[arquivo_atual], "ISO-8859-1");
            editor.move_inicio();
            // inserindo etiquetas
            if (editor.encontra_texto(1, "<text>")) {
                editor.remove(6);
            }
            if (editor.encontra_texto(1, "</header>")) {
                editor.move(9);
                editor.insere_direita("\n<text>\n");
            } else {
                mensageiro.erro("Erro: não foi possível encontrar </header>");
                tem_erros = true;
                continue;
            }
            posicao_atual = editor.le_posicao();
            if (editor.encontra_texto(1, "<body>")) {
                editor.move(6);
                editor.insere_direita("");
            } else {
                editor.move_para_posicao(posicao_atual);
                editor.insere_direita(" <body>\n");
                mensageiro.status("Inserido: <body>");
            }
            if (editor.encontra_texto(1, "</body>")) {
                editor.insere_direita(" ");
            } else {
                posicao_atual = editor.le_posicao();
                if (! editor.encontra_texto(-1, "</text>")) {
                    editor.move_para_posicao(posicao_atual);
                    editor.insere_esquerda("</text>");
                    mensageiro.status("Inserido: </text>");
                }
                editor.insere_direita("</p><body>");
                mensageiro.status("Inserido: </body>");
            }
            editor.move_inicio();
            this.insere_marcacao_paragrafo();
            
            editor.salva_arquivo(diretorio_destino + arquivos[arquivo_atual], "utf-8");
        }
        if (!tem_erros) {
            mensageiro.status("Todos os arquivos processados com sucesso");
        } else {
            mensageiro.status("Alguns arquivos não foram corretamente processados");
        }
        return true;
    }
    
    public boolean gera_corpus_nano_unitex() {
        //
        // processa todos os arquivos do corpus nano e gera versao unitex
        // corpus sem maiusculas, sem xml e com tags unitex
        //
        String arquivo_alfabeto;
        String arquivo_destino;
        String[] arquivos;
        FileOutputStream destino;
        String diretorio_pai;
        String diretorio_unitex;
        Writer escritor;
        int i;
        int j;
        Hashtable<String, String> letras = new Hashtable<String, String>();
        Hashtable<String, String> maiusculas = new Hashtable<String, String>();
        Hashtable<String, String> minusculas = new Hashtable<String, String>();
        boolean tem_erros = false;
        // preparativos
        mensageiro.status("Gerando córpus nano");
        if (diretorios_origem.length == 0) {
            mensageiro.erro("Erro: nenhum diretório informado!");
            return false;
        }
        editor.fecha_arquivo();
        diretorio_unitex = diretorios_origem[0].getParent() + File.separator + "unitex";
        arquivo_alfabeto = diretorio_unitex + File.separator + "Alphabet.txt";
        // carregando hashs com alfabeto
        if (! carrega_alfabeto(arquivo_alfabeto, letras, maiusculas, minusculas)) {
            mensageiro.erro("Erro abrindo " + arquivo_alfabeto);
            return false;
        }
        // carregando arquivo de destino
        // varrendo diretórios de origem
        for (i=0; i<diretorios_origem.length; i++) {
            mensageiro.status("Processando " + diretorios_origem[i].getName());
            arquivo_destino = diretorio_unitex + File.separator + 
                    diretorios_origem[i].getName() + ".txt";
            try {
                destino = new FileOutputStream(arquivo_destino);
                escritor = new OutputStreamWriter(destino, "ISO-8859-1");
                // varrendo subdiretórios recursivamente
                arquivos = lista_arquivos(diretorios_origem[i], ".txt");
                mensageiro.progresso(0, arquivos.length);
                for (j=0; j<arquivos.length; j++) {
                    mensageiro.status("Processando: " + arquivos[j].substring(
                            arquivos[j].lastIndexOf(File.separator)));
                    editor.abre_arquivo(arquivos[j], "ISO-8859-1");
                    remove_maiusculas(maiusculas, minusculas);
                    if (! remove_xml_nano()) {
                        tem_erros = false;
                    }
                    //editor.salva_arquivo("");
                    escritor.write(editor.converte_para_string());
                    editor.fecha_arquivo();
                    mensageiro.progresso(j, arquivos.length);
                }
                escritor.flush();
                escritor.close();
                mensageiro.progresso(1,1);
            } catch (IOException e) {
                mensageiro.erro("Erro processando arquivos: " + e.getMessage());
                return false;
            }

        }
        // finalizando processamento
        mensageiro.seta_texto_alterado(false);
        mensageiro.progresso(1,1);
        if (tem_erros) {
            mensageiro.status("Possiveis erros em tags, corpus gerado em " + diretorio_unitex);
        } else {
            mensageiro.status("Corpus gerado com sucesso em " + diretorio_unitex);
        }
        return true;
    }
    
    private int ignora_xml() {
        //
        // avança para fim do xml quando o próximo caractere denota início 
        //
        int posicao_inicial;
        // validando nota
        if (! editor.le_caracter(1).equals("<")) {
            return 0;
        }
        posicao_inicial = editor.le_posicao();
        editor.move(1);
        editor.encontra_naobranco(1);
        if (! editor.le_token().equals("note")) {
            editor.move_para_posicao(posicao_inicial);
            return 0;
        }
        editor.encontra_caracter(1, "<");
        editor.move(1);
        editor.encontra_naobranco(1);
        if (! editor.le_token().equals("/")) {
            editor.move_para_posicao(posicao_inicial);
            return 0;
        }
        editor.move(1);
        editor.encontra_naobranco(1);
        if (! editor.le_token().equals("note")) {
            editor.move_para_posicao(posicao_inicial);
            return 0;
        }
        editor.move_token(1);
        editor.encontra_naobranco(1);
        if (! editor.le_caracter(1).equals(">")) {
            editor.move_para_posicao(posicao_inicial);
            return 0;
        }
        editor.move(1);
        // retornando bloco ignorado
        return (editor.le_posicao() - posicao_inicial);
    }
    
    private boolean insere_ficha_catalografica(ficha_catalografica ficha) {
        //
        // insere a ficha catalografica no documento atual
        //
        mensageiro.status("Inserindo ficha catalográfica...");
        editor.move_inicio();
        editor.insere_esquerda(
"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n" +
"<!DOCTYPE TEI.2 SYSTEM \"http://docsouth.unc.edu/dtds/teixlite.dtd\">\n" +
"<TEI.2>\n" +
"<teiHeader>\n" +
"   <fileDesc>\n" +
"       <titleStmt>\n" +
"           <title>" + ficha.titulo + "</title>\n" +
"           <author>\n" +
"               <name>" + ficha.autor + "</name>\n" +
"               <date>" + ficha.data_autor + "</date>\n" +
"           </author>\n" +
"           <respStmt>\n" +
"               <resp>Arquivo preparado por</resp>\n" +
"               <name>varios pesquisadores do Projeto DHPB</name>\n" +
"           </respStmt>\n" +
"       </titleStmt>\n" + 
"       <publicationStmt>\n" +
"           <distributor>Projeto do Dicionario Historico do Portugues do Brasil (DHPB), UNESP, Araraquara</distributor>\n" +
"           <date>" + ficha.data_publicacao + "</date>\n" +
"       </publicationStmt>\n" +
"       <sourceDesc>\n" +
"           <biblStruct>\n" +
"               <monogr>\n" +
"                   <title>" + ficha.titulo + "</title>\n" +
"                   <author>" + ficha.autor + "</author>\n" +
"                   <imprint>\n" +
"                       <pubDate>" + ficha.data_edicao + "</pubDate>\n" +
"                   </imprint>\n" +
"               </monogr>\n" + 
"           </biblStruct>\n" +
"       </sourceDesc>\n" +
"   </fileDesc>\n" +
"</teiHeader>\n" + 
"<text>\n" +
"   <body>\n");
        editor.move_para_posicao(editor.le_tamanho_texto());
        editor.insere_esquerda("\t</body>\n</text>\n</TEI.2>");
        mensageiro.status("Ficha inserida");
        return true;
    }
    
    public boolean insere_marcacao_paragrafo() {
        //
        // insere <p> e </p> para delimitar parágrafos (versão Philologic)
        // heurística: 1) ponto seguido por enter e 2) enter seguido por enter
        //
        String caracter_lido;
        int posicao_atual;
        int total_insercoes = 0;
        int posicao_final = -1;
        mensageiro.status("Inserindo marcação de parágrafo...");
        editor.move_inicio();
        if (! this.inicio_marcacao_paragrafo.equals("")) { // pulando o header se houver
            if (! editor.encontra_texto(1, "<" + this.inicio_marcacao_paragrafo + ">")) {
                mensageiro.erro("Erro procurando " + this.inicio_marcacao_paragrafo);
                return false;
            }
            editor.move(this.inicio_marcacao_paragrafo.length()+2);
            posicao_atual = editor.le_posicao();
            editor.encontra_texto(1, "</" + this.inicio_marcacao_paragrafo + ">");
            editor.insere_esquerda("</p> ");
            posicao_final = editor.le_posicao();
            editor.move_para_posicao(posicao_atual);
        }
        editor.encontra_naobranco(1, false);
        editor.insere_esquerda("<p> ");
        posicao_final += 4;
        while (editor.encontra_caracter(1, ".", "\n")) {
            caracter_lido = editor.le_caracter();
            if (caracter_lido.equals(".")) {
                editor.move(1);
                posicao_atual = editor.le_posicao();
                editor.encontra_naobranco(1);
                if (editor.le_caracter().equals("\n")) {
                    editor.move_para_posicao(posicao_atual);
                    if (posicao_final <= editor.le_posicao()) {
                        System.exit(0);
                        mensageiro.status(Integer.toString(total_insercoes) + " inserções realizadas");
                        return true;
                    }
                    editor.insere_esquerda(" </p>");
                    posicao_final += 5;
                    total_insercoes++;
                    if (editor.encontra_naobranco(1, false)) {
                        editor.insere_esquerda("<p> ");
                        posicao_final += 4;
                    }
                }
            } else if (caracter_lido.equals("\n")) {
                editor.move(1); // falha no fim do arquivo, mas não tem problema
                editor.encontra_naobranco(1);
                if (editor.le_caracter().equals("\n")) {
                    editor.encontra_naobranco(-1, false);
                    editor.move(1);
                    if (posicao_final <= editor.le_posicao()) {
                        mensageiro.status(Integer.toString(total_insercoes) + " inserções realizadas");
                        return true;
                    }
                    editor.insere_esquerda(" </p>");
                    posicao_final += 5;
                    total_insercoes++;
                    if (editor.encontra_naobranco(1, false)) {
                        editor.insere_esquerda("<p> ");
                        posicao_final += 4;
                    }
                }
            } else { // nunca deve entrar aqui
                mensageiro.erro("Erro inesperado durante a inserção de marcadores de parágrafos");
                return false;
            }
        }
        return true;
    }    
    
    private int le_natural_i() {
        //
        // le natural ou converte "I", "II", "III" para "1", "11", "111"
        //
        int numero_lido = -1;
        String token_lido;
        token_lido = editor.le_token();
        if (token_lido.equals("I") || token_lido.equals("i")) {
            numero_lido = 1;
        } else if (token_lido.equals("II") || token_lido.equals("ii")) {
                numero_lido = 11;
        } else if (token_lido.equals("III") || token_lido.equals("iii")) {
                numero_lido = 111;
        } else {
                numero_lido = editor.le_natural();
        }
        return numero_lido;
    }
    
    public String[] lista_arquivos(File raiz, String extensao) {
        File[] raizes = new File[1];
        raizes[0] = raiz;
        return lista_arquivos(raizes, extensao);
    }
    
    public String[] lista_arquivos(File[] raizes, String extensao) {
        //
        // lista arquivos recursivamente em um conjunto de diretórios
        //
        int i;
        ArrayList<String> resultado = new ArrayList<String>(0);
        for (i=0; i<raizes.length; i++) {
            lista_arquivos(raizes[i], extensao, resultado);
        }
        return resultado.toArray(new String[resultado.size()]);
    }
    
    private void lista_arquivos(File raiz, String extensao, ArrayList<String> resultado) {
        //
        // lista arquivos recursivamente em um diretório
        //
        int i;
        int j;
        File[] arquivos;
        arquivos = raiz.listFiles();
        java.util.Arrays.sort(arquivos);
        // varrendo arquivos
        for (i=0; i<arquivos.length; i++) {
            if (! arquivos[i].isDirectory()) {
                if (arquivos[i].getName().endsWith(extensao)) {
                    resultado.add(arquivos[i].getAbsolutePath());
                }
            }
        }
        // varrendo diretórios
        for (i=0; i<arquivos.length; i++) {
            if (arquivos[i].isDirectory()) {
                lista_arquivos(arquivos[i], extensao, resultado);
            }
        }
        return;
    }

    private boolean lista_colchetes(String rotulo, Hashtable alfabeto) {
        //
        // lista os colchetes do arquivo aberto
        //
        String bloco_texto;
        boolean comecou_palavra = false;
        String caractere_lido;
        boolean imprimir_bloco = false;
        int posicao_abre;
        int posicao_inicial;
        int posicao_final;
        int tamanho_bloco = 50;
        boolean terminou_colchetes = false;
        posicao_abre = -tamanho_bloco;
        editor.move_inicio();
        do {
            ignora_xml();
            caractere_lido = editor.le_caracter();
            imprimir_bloco = false;
            if ((caractere_lido.equals("<") || caractere_lido.equals("[")) && comecou_palavra) {
                imprimir_bloco = true;
            }
            if (terminou_colchetes && alfabeto.containsKey(caractere_lido) && 
                (editor.le_posicao() - posicao_abre > tamanho_bloco) ) {
                imprimir_bloco = true;
            }
            if (imprimir_bloco) {
                posicao_inicial = editor.le_posicao() - tamanho_bloco;
                if (posicao_inicial < 0) {
                    posicao_inicial = 0;
                }
                posicao_final = editor.le_posicao() + tamanho_bloco;
                bloco_texto = editor.le_caracter(posicao_inicial, posicao_final);
                bloco_texto = rotulo + ": " + bloco_texto.replace('\n', ' ');
                bloco_texto = bloco_texto.replace('\r', ' ');
                System.out.println(bloco_texto);
            }
            comecou_palavra = false;
            terminou_colchetes = false;
            if (alfabeto.containsKey(caractere_lido)) {
                comecou_palavra = true;
            }
            if (caractere_lido.equals(">") || caractere_lido.equals("]")) {
                terminou_colchetes = true;
            }
        } while (editor.move(1) == 1);
        return true;
    }
    
    private String nome_arquivo_sem_diretorio(String nome_arquivo) {
        //
        // remove o diretorio em um nome de arquivo
        //
        int posicao_final = nome_arquivo.length();
        int posicao_inicial = nome_arquivo.lastIndexOf(File.separator);;
        if (posicao_inicial < 0) {
            return nome_arquivo;
        } else {
            return nome_arquivo.substring(posicao_inicial + 1, posicao_final);
        }
    }
    
    private String normaliza_sql(String valor, Hashtable<String, String> maiusculas) {
        //
        // normaliza uma string para que passa ser inserida no banco de dados
        //
        String caracter_atual;
        int i;
        char valor_char[] = valor.toCharArray();
        String valor_min = "";
        // convertendo para minúsculas
        for (i=0; i < valor_char.length; i++) {
            caracter_atual = String.valueOf(valor_char[i]);
            if (maiusculas.containsKey(caracter_atual)) {
                valor_min += maiusculas.get(caracter_atual);
            } else {
                valor_min += caracter_atual;
            }
        }
        valor_min = valor_min.trim();
        // a ordem das operações abaixo deve ser preservada
        valor_min = valor_min.replace("\\", "\\\\");
        valor_min = valor_min.replace("'", "\\'");
        return valor_min;
    }
    
    public protej(protej_avisos gerenciador_de_avisos, processador_texto gerenciador_de_textos) {
        //        
        // inicializando classe protej
        // tarefas (métodos) serão "vetorizados"
        //
        int i;
        editor = gerenciador_de_textos;
        mensageiro = gerenciador_de_avisos;
        // criando objetos tarefa
        for (i = 0; i < this.tamanho_enum_tarefa; i++) {
            tarefas[i] = new tarefa();
        }
        // definindo tarefas
        // susbstituir "//""
        i = 0;
        enum_tarefa.remove_carriage_return = i;
        tarefas[i].habilitado = true;
        tarefas[i].descricao = "converter quebras de linha (retirando carriage return)";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return remove_carriage_return();
            }
        });
        i++;
        // remover igual
        enum_tarefa.remove_igual = i;
        tarefas[i].descricao = "remover igual sucedido por quebra de linha";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return remove_igual();
            }
        });
        // susbstituir "//""
        i++;
        enum_tarefa.substitui_barrabarra = i;
        tarefas[i].descricao = "substituir \"//\" por quebra de linha";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return substitui_barrabarra();
            }
        });
        // processar i
        i++;
        enum_tarefa.substui_i = i;
        tarefas[i].descricao = "processar \"I\" como número";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return substitui_i();
            }
        });
        // processar i em rodapés
        i++;
        enum_tarefa.substui_i_rodape = i;
        tarefas[i].descricao = "processar \"I\",  \"II\" e \"III\" em rodapés";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return substitui_i_rodape();
            }
        });
        // remover ficha catalográfica
        i++;
        enum_tarefa.remove_ficha_catalografica = i;
        tarefas[i].descricao = "remover ficha catalográfica";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return remove_ficha_catalografica();
            }
        });
        // etiquetar numeração das linhas
        i++;
        enum_tarefa.etiqueta_numeracao_paginas = i;
        tarefas[i].descricao = "etiquetar numeração de páginas";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return etiqueta_numeracao_paginas();
            }
        });
        // verifica numeração
        i++;
        enum_tarefa.verifica_numeracao = i;
        tarefas[i].descricao = "verificar numeração marginal";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return verifica_numeracao_marginal();
            }
        });
        // converter notas com asteriscos
        i++;
        enum_tarefa.converte_notas_asteriscos = i;
        tarefas[i].descricao = "converter notas com asteriscos";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return converte_notas_asteriscos();
            }
        });
        // converter notas alfabeticas
        i++;
        enum_tarefa.converte_notas_alfabeticas = i;
        tarefas[i].descricao = "converter notas alfabeticas";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return converte_notas_alfabeticas();
            }
        });
        // converte notas entre parenteses
        i++;
        enum_tarefa.converte_notas_parenteses = i;
        tarefas[i].habilitado = true;
        tarefas[i].descricao = "converter notas entre parenteses";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return converte_notas_parenteses();
            }
        });
        // converte notas que ocupam mais de uma pagina
        i++;
        enum_tarefa.converte_notas_multipaginas = i;
        tarefas[i].descricao = "converter notas que ocupam múltiplas páginas";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return converte_notas_multipaginas();
            }
        });
        // converte notas que referenciam palavras para XML
        i++;
        enum_tarefa.etiqueta_notas_palavras = i;
        tarefas[i].descricao = "converter notas que referenciam palavras para XML";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return etiqueta_notas_palavras();
            }
        });
        // converte notas que referenciam linhas para XML
        i++;
        enum_tarefa.etiqueta_notas_linhas = i;
        tarefas[i].descricao = "converter notas que referenciam linhas para XML";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return etiqueta_notas_linhas();
            }
        });
        // remove numeração marginal
        i++;
        enum_tarefa.remove_numeracao_marginal = i;
        tarefas[i].descricao = "remover numeração marginal";
        // tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return remove_numeracao_marginal();
            }
        });
        // remove marcadores de páginas e rodapés
        i++;
        enum_tarefa.remove_marcadores = i;
        tarefas[i].descricao = "remover marcadores de página e rodapé";
        tarefas[i].habilitado = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return remove_marcadores();
            }
        });
        // remove numeração de parágrafos
        i++;
        enum_tarefa.remove_numeracao_paragrafos = i;
        tarefas[i].descricao = "remover numeração de parágrafos";
        tarefas[i].habilitado = false;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return remove_numeracao_paragrafos();
            }
        });
        
        // gerar corpus unitex
        i++;
        enum_tarefa.gerar_corpus_unitex = i;
        tarefas[i].descricao = "gerar corpus unitex";
        tarefas[i].processa_lote = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return gera_corpus_unitex();
            }
        });
        // gerar corpus philologic
        i++;
        enum_tarefa.gerar_corpus_philologic = i;
        tarefas[i].descricao = "gerar corpus philologic";
        tarefas[i].processa_lote = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return gera_corpus_philologic();
            }
        });
        // gerar corpus nano
        i++;
        enum_tarefa.gerar_corpus_nano = i;
        tarefas[i].descricao = "gerar corpus nano";
        tarefas[i].processa_lote = true;
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return gera_corpus_nano_unitex();
            }
        });
        // dicionários de abreviaturas
        i++;
        enum_tarefa.cria_dicionario_abreviaturas = i;
        tarefas[i].descricao = "criar dicionário de abreviaturas";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return cria_planilha();
            }
        });
        // dicionários de variantes
        i++;
        enum_tarefa.cria_dicionario_variantes = i;
        tarefas[i].descricao = "criar dicionário de variantes";
        tarefas[i].adiciona_acionador_tarefa(new tarefa.aciona_tarefa() {
            public boolean executa_tarefa() {
                return cria_dicionario_grafias();
            }
        });

    }
        
    public boolean remove_carriage_return() {
        //
        // remove todas as ocorrências de "\r" do texto
        //
        int i = 0;
        editor.move_inicio();
        mensageiro.status("Convertendo quebras de linhas (removendo carriage returns)...");
        while (editor.encontra_caracter(1, "\r")) {
            editor.remove(1);
            i++;
        }
        mensageiro.status(Integer.toString(i) + " conversçes");
        return true;
    }
    
    public boolean remove_chaves_unitex() {
        //
        // remove as etiquetas unitex que encapsulam a numeração de página
        //
        int etiquetas_removidas = 0;
        int fim_chave;
        int inicio_chave;
        mensageiro.status("Removendo etiquetas unitex...");
        editor.move_inicio();
        while (editor.encontra_texto(1, ",.N}")) {
            fim_chave = editor.le_posicao() + 4;
            editor.encontra_caracter(-1,"{", "\n");
            if (editor.le_caracter().equals("\n")) {
                editor.move_para_posicao(fim_chave);
                mensageiro.erro("erro na posição do cursor, é necessário remover chaves manualmente");
                editor.atualiza_cursor_externo();
                return false;
            }
            inicio_chave = editor.le_posicao();
            editor.remove(inicio_chave, fim_chave);
            etiquetas_removidas++;
        }
        mensageiro.status(Integer.toString(etiquetas_removidas) + " etiquetas removidas com sucesso");
        return true;
    }
    
    public boolean remove_choice() {
        //
        // remove as tags choice, sic e corr (corr é removida com conteúdo)
        //
        int inicio = 0;
        String tag_lida;
        mensageiro.status("Removendo etiquetas choice...");
        editor.move_inicio();
        do {
            tag_lida = editor.le_tag_xml();
            if (tag_lida.equals("")) {
                continue;
            }
            if (tag_lida.equals("choice") || tag_lida.equals("/choice") ||
                    tag_lida.equals("sic") || tag_lida.equals("/sic")) {
                editor.remove_tag();
            } else if (tag_lida.equals("corr")) {
                inicio = editor.le_posicao();
            } else if (tag_lida.equals("/corr")) {
                if (editor.le_posicao() - inicio < 100) {
                    editor.remove(inicio, editor.le_posicao());
                    editor.remove_tag();
                } else {
                    mensageiro.status("Não foi possivel remover etiquetas em " + editor.pega_arquivo_aberto());
                }
            }
        } while (editor.move(1) == 1);
        mensageiro.status("Etiquetas removidas");
        return true;    
    }
    
    public boolean remove_choice_tudo() {
        //
        // remove todas as ocorrências da etiqueta choice
        //
        String[] arquivos;
        int i;
        arquivos = lista_arquivos(diretorios_origem, ".txt");
        mensageiro.progresso(0, arquivos.length);
        for (i=0; i<arquivos.length; i++) {
            editor.abre_arquivo(arquivos[i]);
            this.remove_choice();
            editor.salva_arquivo("");
            editor.fecha_arquivo();
            mensageiro.progresso(i, arquivos.length);
        }
        mensageiro.seta_texto_alterado(false);
        mensageiro.progresso(1,1);
        mensageiro.status("Processo concluido com sucesso");
        return true;
    }
    
    public boolean remove_colchetes() {
        //
        // remove todas as ocorrências de "<", ">", "[" e "]" do córpus
        //
        int abre_colchete = 0;
        String caracter_lido;
        int fecha_colchete = 0;
        int maior = 0;
        int menor = 0;
        mensageiro.status("Removendo colchetes e colchetes anguralres");
        editor.move_inicio();
        while (editor.encontra_caracter(1, "[", "]", "<", ">")) {
            caracter_lido = editor.le_caracter();
            if (caracter_lido.equals("[")) {
                abre_colchete++;
            } else if (caracter_lido.equals("]")) {
                fecha_colchete++;
            } else if (caracter_lido.equals("<")) {
                menor++;
            } else if (caracter_lido.equals(">")) {
                maior++;
            }
            editor.remove(1);
        }
        mensageiro.status("'[': " + Integer.toString(abre_colchete) + ", ']': " + Integer.toString(fecha_colchete)
            + ", '<': " + Integer.toString(menor) + ", '>': " + Integer.toString(maior));
        return true;
    }
    
    public boolean remove_ficha_catalografica() {
        //
        // remove a primeira pagina (meta-informações) do documento
        //
        int i = 1;
        int linha_final = -1;
        int pagina = 1;
        int posicao_inicial;
        String token_lido;
        mensageiro.status("Removendo ficha catalográfica...");
        editor.move_inicio();
        posicao_inicial = editor.le_posicao();
        do {
            token_lido = editor.le_token();
            if (token_lido.equals("marcadordepagina")) {
                pagina++;
            }
            if (pagina == 3) {
                break;
            }
            if (editor.le_natural() == i) {
                i = i+1;
                linha_final = editor.le_posicao();
            }
        } while (editor.move_token(1) == 1);
        if (linha_final == -1) {
            mensageiro.erro("Falha ao processar ficha catalográfica, remoção manual requerida");
            return false;
        } else {
            editor.move_para_posicao(linha_final);
            editor.encontra_caracter(1, "\n");
            editor.remove(posicao_inicial, editor.le_posicao()+1);
            mensageiro.status("Ficha catalográfica removida até item " + Integer.toString(i-1) + "...");
            return true;
        }
    }  
    
    public boolean remove_igual() {
        //
        // remove todas as ocorrências de "=" do texto
        //
        int posicao_inicial;
        int total_removidos = 0;
        mensageiro.status("Removendo sinais de igual sucedidos por quebra de linha...");
        editor.move_inicio();
        while (editor.encontra_caracter(1, "=")) {
            posicao_inicial = editor.le_posicao();
            editor.move(1);
            editor.encontra_naobranco(1);
            if (editor.le_caracter().equals("\n")) {
                editor.remove(posicao_inicial, editor.le_posicao());
                total_removidos++;
            }
        }
        mensageiro.status("Removidos " + Integer.toString(total_removidos) + " sinais de igual");
        return true;
    }
    
    public boolean remove_maiusculas(Hashtable<String, String> maiusculas,
            Hashtable<String, String> minusculas) {
        //
        // remove blocos de letras maiusculas, exceto letras antecedidas por ponto
        // usado no corpus nano
        //
        String caractere_lido;
        String novo_bloco;
        int total_maiusculas = 0;
        int posicao_atual;
        int posicao_ponto;
        mensageiro.status("Removendo blocos de textos em letras maiusculas...");
        // processando o texto
        editor.move_inicio();
        posicao_atual = editor.le_posicao();
        do {
            caractere_lido = editor.le_caracter();
            if (total_maiusculas >= 10) {
                novo_bloco = "";
                total_maiusculas = 0;
                editor.move_para_posicao(posicao_atual);
                do {
                    caractere_lido = editor.le_caracter();
                    if (caractere_lido.equals(".") || caractere_lido.equals("?") || 
                            caractere_lido.equals("!")) {
                        // pular caractere depios do ponto
                        posicao_ponto = editor.le_posicao();
                        editor.move(1);
                        editor.encontra_naobranco(1, false);
                        editor.move(1);
                        novo_bloco += editor.le_caracter(posicao_ponto, editor.le_posicao());
                        caractere_lido = editor.le_caracter();
                    }
                    if (maiusculas.containsKey(caractere_lido)) {
                        novo_bloco += maiusculas.get(caractere_lido);
                    } else {
                        novo_bloco += caractere_lido;
                    }
                } while (!minusculas.containsKey(caractere_lido) && editor.move(1) == 1);
                editor.remove(posicao_atual, editor.le_posicao());
                editor.remove(1); // primeira minuscula foi inserida
                editor.insere_esquerda(novo_bloco);
                continue;
            } else if (maiusculas.containsKey(caractere_lido)) {
                total_maiusculas++;
            } else if (minusculas.containsKey(caractere_lido)) {
                total_maiusculas = 0;
                posicao_atual = editor.le_posicao() + 1; // somar 1 para pular a minuscula
            }
        } while (editor.move(1) == 1);
        mensageiro.status("Blocos de texto removidos");
        return true;
    }
    
    public boolean remove_marcadores() {
        //
        // remove todas as ocorrências de "=" do texto
        //
        int marcadores_removidos = 0;
        int posicao_inicial;
        String token_lido;
        editor.move_inicio();
        mensageiro.status("Removendo marcadores de página e de rodapé");
        while (editor.encontra_token(1,"marcadorderodape", "marcadordepagina")) {
            if (editor.le_token().equals("marcadorderodape")) {
                posicao_inicial = editor.le_posicao();
                editor.move_token(1);
                editor.encontra_naobranco(1, false);
                token_lido = editor.le_token();
                if (token_lido.equals("marcadorderodape") || token_lido.equals("marcadordepagina") || token_lido.equals("\n") ) {
                    editor.move_para_posicao(posicao_inicial);
                    editor.remove_token(1);
                    marcadores_removidos++;
                } else {
                    mensageiro.erro("Erro: não foi possível remover rodapé não vazio");
                    return false;
                }
            } else {
                editor.remove_token(1);
                marcadores_removidos++;
            }
        }
        mensageiro.status(Integer.toString(marcadores_removidos) + " marcadores removidos");
        return true;
    }
    
    public boolean remove_notas_xml() {
        // 
        // remove notas em xml
        //
        int posicao_inicial;
        int notas_removidas = 0;
        String token_lido;
        mensageiro.status("Removendo notas em xml");
        editor.move_inicio();
        while (editor.encontra_texto(1, "<note")) {
            posicao_inicial = editor.le_posicao();
            editor.move_token(2); // pula o "<" e o "note"
            // encontrando fecha tag
            while (! editor.le_caracter(7).equals("</note>") && ! editor.le_caracter(4).equals(",.N}")) {
                if (editor.move(1) != 1) {
                    break;
                }
            }
            if (! editor.le_caracter(7).equals("</note>")) {
                editor.move_para_posicao(posicao_inicial);
                mensageiro.erro("Erro: nota sem fecha tag na posiçao do cursor");
                return false;
            }
            editor.move(7);
            editor.remove(posicao_inicial, editor.le_posicao());
            notas_removidas++;
        }
        mensageiro.status(Integer.toString(notas_removidas) + " notas removidas");
        return true;
    }
    
    public boolean remove_numeracao_marginal() {
        //
        // ativa dialog para remoção de numeração marginal
        //
        /*if (this.dlg_numeracao_marginal != null) {
            this.dlg_numeracao_marginal.setVisible(true);
        } else {
            mensageiro.aviso("não foi possível carregar caixa de diálogo para ");
        }*/
        return false; // para execução em série não continuar automaticamente
    }
    
    public boolean remove_numeracao_paragrafos() {
        //
        // ativa dialog para remoção de numeração marginal
        //
        int natural_lido;
        int primeira_sequencia_processada = -1;
        int ultima_sequencia_processada = -1;
        mensageiro.status("Removendo numeração de parágrafos...");
        editor.move_inicio();
        editor.encontra_caracter(1, "\n");
        while (editor.move(1) == 1) {
            natural_lido = editor.le_natural();
            if (natural_lido != -1) {
                if (ultima_sequencia_processada == -1) {
                    primeira_sequencia_processada = natural_lido;
                    ultima_sequencia_processada = natural_lido;
                } else {
                    if (natural_lido != ultima_sequencia_processada) {
                        break;
                    }
                }
                editor.remove_natural();
                if (editor.le_caracter().equals(".")) {
                    editor.remove(1);
                }
                ultima_sequencia_processada++;
            }
            editor.encontra_caracter(1, "\n");
        } 
        if (ultima_sequencia_processada == -1) {
            mensageiro.status("Nenhuma numeração removida");
        } else {
            mensageiro.status("numeração removida entre " + Integer.toString(primeira_sequencia_processada)
            + " até " + Integer.toString(ultima_sequencia_processada - 1));
        }
        return true;
    }
    
    public boolean remove_xml_nano() {
        //
        // remove xml de acordo com as regras do córpus nano
        //
        String dado;
        String etiqueta_unitex;
        String fecha_tag;
        int i;
        int posicao_inicial;
        boolean remover_conteudo = false;
        String tag_lida;
        String[] tag_marcada = {"header", "grafico", "figura", "tabela", 
            "keywords", "bibliografia", "abstract", "frame", "formula", 
            "funcao", "outralingua", "omit"};
        int total_marcadas = tag_marcada.length;
        boolean tudo_removido = true;
        int y = 1;
        mensageiro.status("Removendo XML do córpus nano");
        // passo 1: extraindo metadados para gerar etiqueta unitex
        etiqueta_unitex = "";
//        dado = encontra_dado_xml("titleOfText");
//        if (! dado.equals("")) {
//            etiqueta_unitex += "{" + dado + ",.X}\n";
//        }
//        dado = encontra_dado_xml("date");
//        if (! dado.equals("")) {
//            etiqueta_unitex += "{" + dado + ",.X}\n";
//        }
//        dado = encontra_dado_xml("genre");
//        if (! dado.equals("")) {
//            etiqueta_unitex += "{" + dado + ",.X}\n";
//        }
        // passo 2: removendo XML
        editor.move_inicio();
        do {
            tag_lida = editor.le_tag_xml();
            if (tag_lida.equals("")) {
                y = editor.move(1);
            } else {
                y = 1;
                remover_conteudo = false;
                for (i=0; i < total_marcadas; i++) {
                    if (tag_marcada[i].equals(tag_lida)) {
                        remover_conteudo = true;
                        break;
                    }
                }
                if (! remover_conteudo) {
                    if (editor.remove_tag() != 1) {
                        tudo_removido = false;
                    }
                } else {
                    posicao_inicial = editor.le_posicao();
                    fecha_tag = "</" + tag_lida + ">";
                    if (editor.encontra_texto(1, fecha_tag)) {
                        editor.remove(posicao_inicial, editor.le_posicao());
                        if (editor.remove_tag() != 1) {
                            tudo_removido = false;
                            editor.move(1);
                        }
                    } else {
                        mensageiro.status("Erro: " + fecha_tag + " não encontrado");
                        editor.move_para_posicao(posicao_inicial);
                        tudo_removido = false;
                        editor.move(1);
                    }
                }
            }
        } while (y > 0);
        // passo 3: inserindo etiquetas unitex
        if (!etiqueta_unitex.equals("")) {
            editor.move_inicio();
            editor.insere_esquerda(etiqueta_unitex);
            etiqueta_unitex = "\n\n" + etiqueta_unitex;
            while (editor.move(1200) > 0) {  // 1200 é um valor arbitrário
                posicao_inicial = editor.le_posicao();
                editor.encontra_caracter(1, "\n");
                editor.insere_esquerda(etiqueta_unitex);
            } 
        }
        mensageiro.status("XML removidas");
        return tudo_removido;
    }
    
    public boolean substitui_barrabarra() {
        //
        // substitui por "\n" as ocorrências de "//"
        //
        int total_barrabarra = 0;
        mensageiro.status("Substituindo \"//\" por quebra de linha...");
        editor.move_inicio();
        while (editor.encontra_caracter(1, "/")) {
            editor.move(1);
            if (editor.le_caracter().equals("/")) {
                editor.move(-1);
                editor.remove(2);
                editor.insere_esquerda("\n");
                total_barrabarra++;
            }
        }
        mensageiro.status("Substituídos " + Integer.toString(total_barrabarra) + " \"//\"");
        return true;
    }

    public boolean substitui_caracteres_acentuados() {
        //
        // troca e com til e u com til por suas versães com diacríticos
        //
        String letra_e = "\u1EBD";
        String letra_u = "\u0169";
        String letras_e_diacritico = "e\u0303";
        String letras_u_diacritico = "u\u0303";
        int total_u = 0;
        int total_e = 0;
        mensageiro.status("Substituindo 'u' e 'e' por suas versões diacríticas...");
        editor.move_inicio();
        while (editor.encontra_caracter(1, letra_u, letra_e)) {
            if (editor.le_caracter().equals(letra_u)) {
                editor.remove(1);
                editor.insere_esquerda(letras_u_diacritico);
                total_u++;
            } else if (editor.le_caracter().equals(letra_e)) {
                editor.remove(1);
                editor.insere_esquerda(letras_e_diacritico);
                total_e++;
            }
        }
        mensageiro.status(Integer.toString(total_u) + " 'u' substituídos, " + 
                Integer.toString(total_e) + " 'e' substituídos");
        return true;
    }
    
    public boolean substitui_i() {
        //
        // substitui I por 1 em expressões numéricas (exceto I, II, III)
        //
        char caracter_lido;
        String numero = "";
        boolean tem_i = false;
        int total_substituido = 0;
        mensageiro.status("Processando \"i\" como número...");
        editor.move_inicio();
        do {
            caracter_lido = editor.le_caracter().toCharArray()[0];
            if (caracter_lido >= '0' && caracter_lido <= '9') {
                numero = numero + caracter_lido;
            } else if (caracter_lido == 'I') {
                numero = numero + "1";
                tem_i = true;
            } else {
                if ( !(numero.equals("") || numero.equals("1") || numero.equals("11") || numero.equals("111")) && tem_i) {
                    editor.remove(- numero.length());
                    editor.insere_esquerda(numero);
                    total_substituido++;
                }
                numero = "";
                tem_i = false;
            }
        } while (editor.move(1) == 1);
        mensageiro.status(Integer.toString(total_substituido) + " números processados");
        return true;
    }
    
    public boolean substitui_i_rodape() {
        //
        // substitui I, II e III por 1, 11 e 111 em rodapés
        //
        String token_lido;
        int total_substituido = 0;
        mensageiro.status("Processando \"I\",  \"II\" e \"III\" em rodapés...");
        editor.move_inicio();
        while (editor.encontra_token(1, "marcadorderodape")) {
            while (editor.encontra_token(1, "\n", "marcadordepagina")) {
                if (editor.le_token().equals("marcadordepagina")) {
                    break;
                }
                if (editor.move_token(1) != 1) {
                    break;
                }
                editor.encontra_naobranco(1);
                token_lido = editor.le_token();
                if (token_lido.equals("I")) {
                    editor.remove_token(1);
                    editor.insere_esquerda("1");
                    total_substituido++;
                } else if (token_lido.equals("II")) {
                    editor.remove_token(1);
                    editor.insere_esquerda("11");
                    total_substituido++;
                } else if (token_lido.equals("III")) {
                    editor.remove_token(1);
                    editor.insere_esquerda("111");
                    total_substituido++;
                }
            }
        }
        mensageiro.status(Integer.toString(total_substituido) + " números em rodapés alterados");
        return true;
    }

    private int string_para_unicode(String letra) {
        //
        // retorna o inteiro que representa um caracter unicode
        //
        return (int) letra.toCharArray()[0];
    }
  
    public boolean trata_colchetes() {
        //
        // reporta/altera os colchetes nos arquivos do córpus
        //
        Hashtable alfabeto;
        String arquivo_alfabeto;
        String[] arquivos;
        String diretorio_raiz;
        String[] diretorios;
        int i;
        int j;
        mensageiro.status("Processando colchetes...");
        // definindo diretório de trabalho
        diretorio_raiz = diretorio_pai(diretorio_pai(editor.pega_arquivo_aberto()));
        editor.fecha_arquivo();
        // criando hash do alfabeto
        arquivo_alfabeto = diretorio_raiz + File.separator + "unitex" + File.separator + "Alphabet.txt";
        alfabeto = carrega_alfabeto(arquivo_alfabeto);
        // varrendo diretórios, arquivos e bytes
        diretorios = new java.io.File(diretorio_raiz).list();
        java.util.Arrays.sort(diretorios);
        for (i=0; i<diretorios.length; i++) {
            if (! diretorios[i].substring(0,6).equals("corpus")) {
                continue;
            }
            arquivos = new java.io.File(diretorio_raiz + File.separator + diretorios[i]).list();
            java.util.Arrays.sort(arquivos);
            for (j=0; j<arquivos.length; j++) {
                if (! arquivos[j].endsWith(".txt")) {
                    continue;
                }
                // abrindo ficha catalográfica
                editor.abre_arquivo(diretorio_raiz + File.separator + diretorios[i] + File.separator + arquivos[j]);
                lista_colchetes(arquivos[j], alfabeto);
                editor.fecha_arquivo();
            }
        }
        mensageiro.seta_texto_alterado(false);
        mensageiro.status("Colchetes analisados");
        return true;        
    }
    
    public boolean verifica_numeracao_marginal() {
        //
        // verifica última numeracao marginal do documento
        // sempre retorna falso, pois a análise do usuário é requerida
        //
        int esperado = 0;
        int i = 5;
        int j = 0;
        int numero_lido;
        int posicao = 0;
        mensageiro.status("Verificando numeração marginal...");
        editor.move_inicio();
        // detectando último número em seqüência
        do {
            numero_lido = editor.le_natural();
            if (numero_lido == i) {
                posicao = editor.le_posicao();
                i += 5;
            }
            if (numero_lido % 5 == 0) {
                esperado = numero_lido;
            }
            // pulando rodape
            if (editor.le_token().equals("marcadorderodape")) {
                if (editor.encontra_token(1, "marcadordepagina")) {
                    j = 1;
                } else {
                    j = 0;
                }
            } else {
                j = editor.move_token(1);
            }
        } while (j != 0);
        editor.move_para_posicao(posicao);
        mensageiro.status("numeração marginal encontrada até " + Integer.toString(i-5) + 
                ". Esperado até " + Integer.toString(esperado));
        return false;
    }

    public boolean volta_tarefa() {
        //
        // seleciona a tarefa anterior
        //
        int nova_tarefa = tarefa_selecionada;
        nova_tarefa--;
        while (nova_tarefa >= 0 && tarefas[nova_tarefa].habilitado == false) {
            nova_tarefa--;
        }
        if (nova_tarefa >= 0) {
            tarefa_selecionada = nova_tarefa;
            return true;
        } else {
            return false;
        }
    }
}
